#ifndef _DEBUG_H_
#define _DEBUG_H_

//Visual StudiõXebvsɂ́uXebvCvuXebvI[o[vāuXebvAEgv3ނ܂B
//XebvC 		F11
//XebvI[o[ 	F10
//XebvAEg 	Shift + F11

//XebvC͍łXebvPʂfobO@łB{I1sPʂŎs܂itAZu\ɂꍇ̓AZu1sPʁjBāAׂPʂł̓`FbNł܂B̃XebvsƁA֐̓ɂǂǂ邱Ƃł܂B
//XebvI[o[͓1sPʂŎŝłA֐ꍇ̊֐sĎ̍sɈڍs܂B֐̓ɓ炸΂߁uI[o[vłB
//XebvAEg͏2Ƃ}Ci[Ȋ܂A͍sĂ֐̊OiĂяojɏo܂ŃvOi߂Xebvs@łB̊֐̓`FbNł̂ŌĂяoɖ߂肽͂܂܂܂BɎg܂B
//XebvsIăvOĂё点ɂ́usvɂ܂B[fobO][s]ło܂AV[gJbgL[łuF5v̂ʏłB

//tu[N|Cg
//ɂ́Axu[N|C^ݒ肵s̐Ԋۂ̏ŉENbN邱Ƃŏo郁j[̒uvI܂
//Juu[N|Cg̏vEBhEɏ܂B
//͂̍sifƎvΗǂł傤BłA錾ĂȂϐw肵ĂĂ܂܂

#include "unicode.hpp"
#include <tchar.h>
#include <stdio.h>
#include <windows.h>
#include <typeinfo>
#include <crtdbg.h>
#include <assert.h>

// CRT[Nop
#ifdef _DEBUG
#	define CRTMEMORYLEAK_CHECK() _CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF)
#else
#	define CRTMEMORYLEAK_CHECK() // 
#endif

// CRT[Nӏo
#ifdef _DEBUG
#	define CRTMEMORYLEAK_POINT(x) _CrtSetBreakAlloc(x)
#else
#	define CRTMEMORYLEAK_POINT(x) // 
#endif


/////////////////////////////////////////////////////////////
//	fobNEBhEo
/////////////////////////////////////////////////////////////
#ifdef _DEBUG
#	define TRACE( str, ... ) \
      { \
		OutputDebugString( tformat<TCHAR>(str,__VA_ARGS__).c_str() ); \
      }
#else
#	define TRACE( str, ... ) // 
#endif

/////////////////////////////////////////////////////////////
//	R\[o
/////////////////////////////////////////////////////////////
#ifdef _DEBUG
#	define PRINT( str, ... ) \
      { \
		_tprintf( str, __VA_ARGS__ ); \
      }
#else
#	define PRINT( str, ... ) // 
#endif


/////////////////////////////////////////////////////////////
//	bZ[W{bNX
/////////////////////////////////////////////////////////////
#define MSGBOX( str, ...) \
      { \
		  MessageBox(NULL,tformat<TCHAR>(str,__VA_ARGS__).c_str(),NULL,MB_OK); \
      }

/////////////////////////////////////////////////////////////
//	R\[I[v
/////////////////////////////////////////////////////////////

class Console
{
private:
	FILE* m_Out;
	FILE* m_In;
public:
	Console():m_Out(NULL),m_In(NULL){
		AllocConsole();	
		freopen_s(&m_Out,"CONOUT$", "w", stdout); 
		freopen_s(&m_In,"CONIN$", "r", stdin);   
	}
	virtual ~Console(){
		if(m_Out != NULL) 
			fclose(m_Out);
		if(m_In != NULL) 
			fclose(m_In);
		FreeConsole();
	}
};



/////////////////////////////////////////////////////////////
//	AT[g	
/////////////////////////////////////////////////////////////
#ifndef ASSERT // AT[gd`h~
#define ASSERT

#ifdef _DEBUG

	//UNICODE
	#ifdef UNICODE

		#define ASSERT_MSG(msg) \
		(void) ((1 != _CrtDbgReportW(_CRT_ASSERT, _CRT_WIDE(__FILE__), __LINE__, NULL, msg)) || \
		(_CrtDbgBreak(), 0))
		#define ASSERT_EX(expr, msg) \
		(void) ((!!(expr)) || \
		(1 != _CrtDbgReportW(_CRT_ASSERT, _CRT_WIDE(__FILE__), __LINE__, NULL, msg)) || \
		(_CrtDbgBreak(), 0))

	//MULTIBYTE
	#else


		#define ASSERT_MSG(msg) \
		(void) ((1 != _CrtDbgReport(_CRT_ASSERT, __FILE__, __LINE__, NULL, msg)) || \
		(_CrtDbgBreak(), 0))
		#define ASSERT_EX(expr, msg) \
		(void) ((!!(expr)) || \
		(1 != _CrtDbgReport(_CRT_ASSERT, __FILE__, __LINE__, NULL, msg)) || \
		(_CrtDbgBreak(), 0))


	#endif	// UNICODE

// Releaseł͋
#else

#define ASSERT_MSG(msg) 
#define ASSERT_EX(expr, msg) 

#endif	// _DEBUG

#endif	// ASSERT

#endif	// _DEBUG_H_