#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "drawer.h"
#include "debugcamera.h"

class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	DirectInput	m_DirectInput;
	Texture		m_Texture;
	BillBoard	m_BillBoard;
	DebugCamera	m_Camera;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());

		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		
		// eNX`[h
		m_Texture.Create(_T("player.png"),m_Direct3D9.GetDevice(),384,384,0xff78c380);

		// r{[h쐬
		m_BillBoard.Create(m_Direct3D9.GetDevice(),32,48,D3DXVECTOR3(0,0,100));
		// UV؂
		m_BillBoard.SetDivideUV(12,8);
		// UVԍZbg
		m_BillBoard.SetUV(0,2);

		// _[Xe[g̕ύX
		SetRenderState(m_Direct3D9.GetDevice(),RENDER_ALPHATEST,0x10);
		// eNX`Tv[̕ύX
		SetSamplerState(m_Direct3D9.GetDevice(),SAMPLER_LINEAR);

		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		// XN[hԂ
		m_Direct3D9.ScreenClear(0xff808080);
		if(m_Direct3D9.BeginScene()){

			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);

			Drawer::DrawPlanePolygon(m_BillBoard,m_Texture);

			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}