#include "window.h"
#include "direct3d9.h"
#include "geometory.h"
#include "camera.h"

class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	Camera		m_Camera;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// 􉽃IuWFNg
		Geometory::Init(m_Direct3D9.GetDevice());
		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,20,-10),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		
		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle()
	{
		// JXV
		m_Camera.Update();
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		// ʓhԂ
		m_Direct3D9.ScreenClear(0xff808080);
		if(m_Direct3D9.BeginScene()){

			//////////////////////////////////
			//	3IuWFNg`
			//////////////////////////////////

			// Obh`
			Geometory::DrawGrid(5.0f);
			// 3`
			Geometory::DrawAxis(5.0f);
			// iRayj`
			Geometory::DrawLine(D3DXVECTOR3(0,0,0),D3DXVECTOR3(2,2,2),NULL,0xff000000);
			// Op``
			D3DXVECTOR3 tri[3] = { D3DXVECTOR3(-10,0,-2),D3DXVECTOR3(-7.5f,0,3),D3DXVECTOR3(-5,0,-2)};
			Geometory::DrawTriangle(tri,NULL,0xff00ffff);
			// Op``
			D3DXVECTOR3 filltri[3] = { D3DXVECTOR3(5,0,-2),D3DXVECTOR3(7.5f,0,3),D3DXVECTOR3(10,0,-2)};
			Geometory::DrawFillTriangle(filltri,NULL,0xffaabbcc);
			// ̐`
			Geometory::DrawCube(NULL,0xffffff00);
			// `
			Geometory::DrawSphere(NULL,0xffff00ff,D3DXVECTOR3(-5,0,3));
			// JvZ`
			D3DXMATRIX trans;
			D3DXMatrixTranslation(&trans,5.0f,0.0f,4.0f);
			Geometory::DrawCapsule(&trans,0xff008080,1.0f,5.0f);

			//////////////////////////////////
			//	2IuWFNg`
			//////////////////////////////////

			// `
			Geometory::DrawLine(D3DXVECTOR2(10,30),D3DXVECTOR2(100,30),0xff00ff00);
			// ~`
			Geometory::DrawCircle(20.0f,D3DXVECTOR2(40,60),0xff0000ff);
			// ~`
			Geometory::DrawFillCircle(20.0f,D3DXVECTOR2(90,60),0xff00ff00);
			// ``
			RECT rect = {70,100,120,150};
			Geometory::DrawRect(rect,0xffff0000);
			// ``
			RECT fillrect = {10,100,60,150};
			Geometory::DrawFillRect(fillrect,0xffffff00);

			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}