#include "window.h"

Window*	Window::m_pThis = Window::StaticField();	// ꎞۑCX^X|C^
std::map<HWND,Window*>	Window::m_Windows;	// Idlep

// EBhENXo^
bool Window::RegistWindow()
{
	HINSTANCE hInst = GetModuleHandle(NULL);
	// VvEBhENXݒ
	WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS,Window::WndProcManager, 0,0,hInst,
		(HICON)LoadImage(NULL,MAKEINTRESOURCE(IDI_APPLICATION),IMAGE_ICON,0,0,LR_DEFAULTSIZE | LR_SHARED),
		(HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED), 
		(HBRUSH)GetStockObject(WHITE_BRUSH), NULL, WC_BASIC , NULL};

	// VvEBhENX쐬
	if(!RegisterClassEx(&wcex)) 
		return false;

	return true;
}

// ÓItB[hĂяoix̂݌Ăяoj
Window* Window::StaticField()
{
	Window::RegistWindow();
	return NULL;
}


// RXgN^
Window::Window():m_hWnd(NULL),m_DefProc(NULL)
{
}
// fXgN^
Window::~Window()
{
}


//--------------------------------------------------------------------//
//	EBhE쐬
//
//	F		Title		^Cg
//				Width		
//				Height		
//				X			XW
//				Y			YW
//				ClassName	EBhENX
//				hParentWnd	eEBhEnh
//				Style		EBhEX^C
//				ExStyle		EBhEgX^C
//				hMenu		j[nh̓\[XID
//
//	߂lF	true:	쐬
//				false:	쐬s
//--------------------------------------------------------------------//
bool Window::CreateWnd(
		const TCHAR* Title,int Width,int Height,
		int X,int Y,const TCHAR* ClassName,HWND hParentWnd,DWORD Style,DWORD ExStyle,HMENU hMenu)
{
	// eEBhEnhꍇ
	if(hParentWnd)
		Style |= WS_CHILD;
	else
		Style |= WS_CLIPCHILDREN;

	// NCAg̈̃TCYEBhETCYݒ
	RECT rect = { 0, 0, Width, Height };
	AdjustWindowRectEx( &rect, Style, (hMenu ? TRUE : FALSE), ExStyle );
	Width = rect.right - rect.left;
	Height = rect.bottom - rect.top;


	HINSTANCE hInstance = (HINSTANCE)GetModuleHandle(NULL);
	m_pThis = this;
	m_hWnd = CreateWindowEx(ExStyle,ClassName,
		Title,Style,X,Y,Width,Height,hParentWnd,hMenu,hInstance,NULL);

	if(!m_hWnd)
		return false;

	// EBhE̓o^
	m_Windows.insert(std::pair<HWND,Window*>(m_hWnd,this));

	// EBhENCAg̈XV
	UpdateWindow(m_hWnd);			
	// EBhE\
	ShowWindow(m_hWnd, SW_SHOW);	

	// ftHgvV[W擾
	m_DefProc = (WNDPROC)(LONG_PTR)GetWindowLong( m_hWnd, GWL_WNDPROC );

	return true;
}

//--------------------------//
//	EBhEnh擾
//
//	߂lFEBhEnh
//--------------------------//
HWND Window::GetWndHandle(){
	return m_hWnd;
}


//-----------------------------------------------------//
//  EBhEvV[W̊Ǘ
//
//	F	hWnd	EBhEnh
//			msg		bZ[W
//			wParam	p[^
//			lParam	p[^
//
//	߂lF
//-----------------------------------------------------//
LRESULT CALLBACK Window::WndProcManager(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	Window* pWindow = (Window*)(LONG_PTR)GetWindowLong(hWnd,GWL_USERDATA);

	//this|C^擾łꍇ...
	if( pWindow != NULL)
	{
		LRESULT lResult = pWindow->WndProc( hWnd, msg, wParam, lParam);
		return lResult;
	}
	//this|C^擾łȂꍇ...
	else
	{

		// EBhE̍쐬̏ꍇ...
		if( msg == WM_CREATE || msg == WM_INITDIALOG){
			// vpeBXgɃIuWFNgnh(this|C^)ݒ肷
			SetWindowLong( hWnd, GWL_USERDATA, (LONG)(LONG_PTR)(m_pThis) );
			//printf("Create %s\n",typeid(*m_Instance).name());// ǂ̃EBhE^CvȂ̂\
			// bZ[W̍đM
			SendMessage(hWnd,msg,wParam,lParam);

			m_pThis = NULL;	// o^̂ňꎞCX^X|C^i[̉
		}
	}

	return DefWindowProc(hWnd,msg,wParam,lParam);
}

//-----------------------------------------------------//
//	EBhEvV[W
//	ftHg̏DefWindowProc֐ōs
//
//	F	hWnd	EBhEnh
//			msg		bZ[W
//			wParam	p[^
//			lParam	p[^
//
//	߂lF
//-----------------------------------------------------//
LRESULT CALLBACK Window::WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	
	switch(msg){
		HANDLE_MSG(hWnd,WM_CREATE,OnCreate);	
		HANDLE_MSG(hWnd,WM_CLOSE,OnClose);
		HANDLE_MSG(hWnd,WM_DESTROY,OnDestroy);
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}


//------------------------------------------------------//
//	EBhE쐬bZ[W
//
//	F	hWnd			EBhEnh
//			lpCreateStruct	EBhE쐬
//------------------------------------------------------//
BOOL Window::OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
	return TRUE;
}

//------------------------------------------------------//
//	EBhEN[YbZ[W
//
//	F	hWnd	EBhEnh
//------------------------------------------------------//
void Window::OnClose(HWND hWnd){
	DestroyWindow(hWnd);
}

//------------------------------------------------------//
//	EBhEjbZ[W
//
//	F	hWnd	EBhEnh
//------------------------------------------------------//
void Window::OnDestroy(HWND hWnd){
	ApplicationEnd();
}

//-----------------------------------------------------//
//	bZ[WĂȂƂɍs
//	DirectXȂǂ̏͂ōs
//-----------------------------------------------------//
void Window::Idle(){
}

//-----------------------------------------------------------------------------//
//	bZ[W[v
//-----------------------------------------------------------------------------//
void Window::MessageLoop()
{
	// C bZ[W [v
	MSG msg = {}; 
	while(msg.message != WM_QUIT) {
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else{

			
			std::map<HWND,Window*>::iterator it;
			for(it = m_Windows.begin();it != m_Windows.end();)
			{
				// EBhEłɎłꍇ
				if(!IsWindow(it->first)){
					it = m_Windows.erase(it);
					continue;
				}

				// EBhEĂ鎞鏈
				WINDOWPLACEMENT wndpl;
				GetWindowPlacement(it->first, &wndpl);	// EChȄԂ擾
				if((wndpl.showCmd != SW_HIDE) && 
					(wndpl.showCmd != SW_MINIMIZE) &&
					(wndpl.showCmd != SW_SHOWMINIMIZED) &&
					(wndpl.showCmd != SW_SHOWMINNOACTIVE) )
				{
					// 
					it->second->Idle();
				}

				++it;
			}
			
		}
	}
}

// AvP[VIbZ[WM
void ApplicationEnd(){
	PostQuitMessage(0); 
}
