#include "geometory.h"

Effect							Geometory::m_Effect;				// 􉽃IuWFNgGtFNg
IDirect3DVertexDeclaration9*	Geometory::m_pVertexDecl2D = NULL;	// 2􉽃IuWFNg_\̐錾
IDirect3DVertexDeclaration9*	Geometory::m_pVertexDecl3D = NULL;	// 3􉽃IuWFNg_\̐錾

// 
bool Geometory::Init(IDirect3DDevice9* pD3DDevice)
{
	// GtFNgǂݍ
	if(!m_Effect.Create(pD3DDevice,_T("geometory.cfx")))
		return false;

	// 2􉽃IuWFNg_\̒`
	D3DVERTEXELEMENT9 decl2d[] = 
	{
		{ 0, 0,	 D3DDECLTYPE_FLOAT4,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITIONT, 0 },
		{ 0, 16, D3DDECLTYPE_D3DCOLOR,  D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR	 , 0 },
		D3DDECL_END()
	};

	// 2􉽃IuWFNg_\̐錾쐬
	if(FAILED(pD3DDevice->CreateVertexDeclaration( decl2d, &m_pVertexDecl2D )))
	{
		ASSERT_MSG(_T("2􉽃IuWFNg_\̐錾쐬Ɏs܂\n"));
		return false;
	}

	// 3􉽃IuWFNg_\̒`
	D3DVERTEXELEMENT9 decl3d[] = 
	{
		{ 0, 0,	 D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION , 0 },
		{ 0, 12, D3DDECLTYPE_D3DCOLOR,  D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR	 , 0 },
		D3DDECL_END()
	};

	// 3􉽃IuWFNg_\̐錾쐬
	if(FAILED(pD3DDevice->CreateVertexDeclaration( decl3d, &m_pVertexDecl3D )))
	{
		ASSERT_MSG(_T("3􉽃IuWFNg_\̐錾쐬Ɏs܂\n"));
		return false;
	}

	atexit(Geometory::Release);
	return true;
}

// 
void Geometory::Release()
{
	// _\̐錾
	SafeRelease(m_pVertexDecl3D);
	SafeRelease(m_pVertexDecl2D);
}

//////////////////////////////////////////////////////////////////////////////////////////
//								2IuWFNg`										//
//////////////////////////////////////////////////////////////////////////////////////////


//-------------------------------------------//
//	`
//
//	F	Start		n_
//			End			I_
//			Color		F
//
//	߂lF true:	`搬
//			false:	`掸s
//-------------------------------------------//
bool Geometory::DrawLine(const D3DXVECTOR2& Start,const D3DXVECTOR2& End,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW2D);
	// GtFNgJn
	m_Effect.Begin();

	Vtx2D v[2] =
	{
		{Start.x,Start.y,0.0f,1.0f,Color},
		{End.x,End.y,0.0f,1.0f,Color},
	};
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl2D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,v,sizeof(Vtx2D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-------------------------------------------//
//	ې`
//
//	F	R		a
//			Pos		ʒu
//			Color	F
//			
//	߂lF	true:	`搬
//			false:	`掸s
//-------------------------------------------//
bool Geometory::DrawCircle(float R,const D3DXVECTOR2& Pos,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW2D);
	// GtFNgJn
	m_Effect.Begin();

	const int div = 17;
	const float divide = (D3DX_PI * 2)/ (div - 1);
	Vtx2D v[div];
	
	float phi = 0.0f;
	for(int i = 0;i < div;++i){
		v[i].x = R * cosf(phi) + Pos.x;
		v[i].y = R * sinf(phi) + Pos.y;
		v[i].z = 0.0f;
		v[i].rhw = 1.0f;
		v[i].color = Color;
		phi += divide;
	}
	
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl2D)))
		return false;	
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,div - 1,v,sizeof(Vtx2D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-------------------------------------------//
//	ە`
//
//	F	R		a
//			Pos		ʒu
//			Color	F
//			
//	߂lF	true:	`搬
//			false:	`掸s
//-------------------------------------------//
bool Geometory::DrawFillCircle(float R,const D3DXVECTOR2& Pos,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW2D);
	// GtFNgJn
	m_Effect.Begin();

	const int div = 17;
	const float divide = (D3DX_PI * 2)/ (div - 1);
	Vtx2D v[div + 1];
	

	v[0].x = Pos.x;
	v[0].y = Pos.y;
	v[0].z = 0.0f;
	v[0].rhw = 1.0f;
	v[0].color = Color;

	float phi = 0.0f;
	for(int i = 1;i < div + 1;++i){
		v[i].x = R * cosf(phi) + Pos.x;
		v[i].y = R * sinf(phi) + Pos.y;
		v[i].z = 0.0f;
		v[i].rhw = 1.0f;
		v[i].color = Color;
		phi += divide;
	}
	
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl2D)))
		return false;	
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,div - 1,v,sizeof(Vtx2D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-------------------------------------------//
//	``
//
//	F	Rect		`
//			Color		F
//
//	߂lF	true:	`搬
//			false:	`掸s
//-------------------------------------------//
bool Geometory::DrawRect(const RECT& Rect,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW2D);
	// GtFNgJn
	m_Effect.Begin();

	RECT rect = Rect;	

	Vtx2D v[8] =
	{
		{(float)rect.left,(float)rect.top,0.0f,1.0f,Color},
		{(float)rect.right,(float)rect.top,0.0f,1.0f,Color},

		{(float)rect.right,(float)rect.top,0.0f,1.0f,Color},
		{(float)rect.right,(float)rect.bottom,0.0f,1.0f,Color},

		{(float)rect.right,(float)rect.bottom,0.0f,1.0f,Color},
		{(float)rect.left,(float)rect.bottom,0.0f,1.0f,Color},

		{(float)rect.left,(float)rect.bottom,0.0f,1.0f,Color},
		{(float)rect.left,(float)rect.top,0.0f,1.0f,Color},
	};

	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl2D)))
		return false;	
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,4,v,sizeof(Vtx2D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-------------------------------------------//
//	``
//
//	F	Rect		`
//			Color		F
//
//	߂lFtrue:	`搬
//			false:	`掸s
//-------------------------------------------//
bool Geometory::DrawFillRect(const RECT& Rect,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW2D);
	// GtFNgJn
	m_Effect.Begin();

	RECT rect = Rect;	
	
	Vtx2D v[4] =
	{
		// 
		{(float)rect.left,(float)rect.bottom,0.0f,1.0f,Color},
		// 
		{(float)rect.left,(float)rect.top,0.0f,1.0f,Color},
		// E
		{(float)rect.right,(float)rect.bottom,0.0f,1.0f,Color},
		// E
		{(float)rect.right,(float)rect.top,0.0f,1.0f,Color}

	};

	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl2D)))
		return false;	
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,v,sizeof(Vtx2D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
//								3IuWFNg`										//
//////////////////////////////////////////////////////////////////////////////////////////

//------------------------------------------//
//	GtFNgɕϊsZbg
//	
//		F	pWorldMtx	[hϊs
//
//	߂lF	true:	Zbg
//			false:	Zbgs
//------------------------------------------//
bool Geometory::SetEffectParam(const D3DXMATRIX* pWorldMtx)
{
	
	// [hϊsZbg
	if(pWorldMtx != NULL){
		if(!m_Effect.SetMatrix(_T("g_mWorld"),pWorldMtx))
			return false;
	}
	else{
		D3DXMATRIX	Mtx;
		D3DXMatrixIdentity(&Mtx);
		m_Effect.SetMatrix(_T("g_mWorld"),&Mtx);
	}

	// r[ϊsZbg
	if(!m_Effect.SetMatrix(_T("g_mView"),&Object3D::GetViewMatrix()))
		return false;
	// ˉeϊsZbg
	if(!m_Effect.SetMatrix(_T("g_mProj"),&Object3D::GetProjMatrix()))
		return false;
	
	return true;
}

//-----------------------------------------------
//	Obh`
//
//	F	Wide		
//			Divide		
//			pWorldMtx	[hϊs
//			Color		F
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawGrid(float Wide,int Divide,const D3DXMATRIX* pWorldMtx,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// `Ȃ
	if(Divide < 1)
		return false;

	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);

	// GtFNgJn
	m_Effect.Begin();

	// ̒_f[^(vɃf[^Ă)	
	std::vector<Vtx3D> v;
	v.resize(Divide * 4 + 8);

	//cC
	for(unsigned int i = 0;i < v.size()/2;i += 2)
	{
		v[i].x = -Wide/2.0f + i/2 * Wide/(Divide+1);
		v[i].y = 0.0f;
		v[i].z = Wide/2.0f;
		v[i].color = Color;

		v[i + 1].x = -Wide/2.0f + i/2 * Wide/(Divide+1);
		v[i + 1].y = 0.0f;
		v[i + 1].z = -Wide/2.0f;
		v[i + 1].color = Color;
	}
	
	//C
	for(unsigned int i = v.size()/2;i < v.size();i += 2)
	{
		v[i].x = Wide/2.0f;
		v[i].y = 0.0f;
		v[i].z = -Wide/2.0f + (i - v.size()/2)/2 * Wide/(Divide+1);
		v[i].color = Color;

		v[i + 1].x = -Wide/2.0f;
		v[i + 1].y = 0.0f;
		v[i + 1].z = -Wide/2.0f + (i - v.size()/2)/2 * Wide/(Divide+1);
		v[i + 1].color = Color;
	}
				
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,v.size()/2,&v[0],sizeof(Vtx3D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}


//-----------------------------------------------
//	3`
//
//	F	Length		̒
//			pWorldMtx	[hϊs
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawAxis(float Length,const D3DXMATRIX* pWorldMtx)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);

	// GtFNgJn
	m_Effect.Begin();

	Vtx3D v[3][2] = {
		{ {-Length/2.0f,0.0f,0.0f,0xffff0000},{Length/2.0f,0.0f,0.0f,0xffff0000} },
		{ {0.0f,-Length/2.0f,0.0f,0xff00ff00},{0.0f,Length/2.0f,0.0f,0xff00ff00} },
		{ {0.0f,0.0f,-Length/2.0f,0xff0000ff},{0.0f,0.0f,Length/2.0f,0xff0000ff} },
	};
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,3,v,sizeof(Vtx3D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-----------------------------------------------
//	`
//
//	F	Start		n_
//			End			I_
//			pWorldMtx	[hϊs
//			Color		F
//
//	߂lF	true:	`搬
//			false:	`掸s
//-----------------------------------------------
bool Geometory::DrawLine(const D3DXVECTOR3& Start,const D3DXVECTOR3& End,const D3DXMATRIX* pWorldMtx,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);

	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);

	// GtFNgJn
	m_Effect.Begin();

	Vtx3D v[2] = 
	{
		{Start.x,Start.y,Start.z,Color},
		{End.x,End.y,End.z,Color}
	};
	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,1,v,sizeof(Vtx3D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//--------------------------------------------
//	Op``
//
//	F	Vtx			Op`̒_
//			pWorldMtx	[hϊs
//			Color		F
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawTriangle(const D3DXVECTOR3 Vtx[3],const D3DXMATRIX* pWorldMtx,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);
	
	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);
	
	// GtFNgJn
	m_Effect.Begin();

	Vtx3D v[3][2] = {
		{ {Vtx[0].x,Vtx[0].y,Vtx[0].z,Color},{Vtx[1].x,Vtx[1].y,Vtx[1].z,Color} },
		{ {Vtx[1].x,Vtx[1].y,Vtx[1].z,Color},{Vtx[2].x,Vtx[2].y,Vtx[2].z,Color} },
		{ {Vtx[2].x,Vtx[2].y,Vtx[2].z,Color},{Vtx[0].x,Vtx[0].y,Vtx[0].z,Color} }
	};

	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,3,v,sizeof(Vtx3D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//--------------------------------------------
//	Op``
//
//	F	Vtx			Op`̒_
//			pWorldMtx	[hϊs
//			Color		F
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawFillTriangle(const D3DXVECTOR3 Vtx[3],const D3DXMATRIX* pWorldMtx,DWORD Color)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);
	
	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);
	
	// GtFNgJn
	m_Effect.Begin();

	Vtx3D v[3] = {
		{Vtx[0].x,Vtx[0].y,Vtx[0].z,Color},
		{Vtx[1].x,Vtx[1].y,Vtx[1].z,Color},
		{Vtx[2].x,Vtx[2].y,Vtx[2].z,Color}
	};
	
	// _\̐錾Zbg	
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_TRIANGLELIST,1,v,sizeof(Vtx3D))))
		return false;

	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//--------------------------------------------
//	̐`
//
//	F	pWorldMtx	[hϊs
//			Color		F
//			Min			̂̑Ίpŏ_
//			Max			̂̑Ίpő_
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawCube(const D3DXMATRIX* pWorldMtx,DWORD Color,const D3DXVECTOR3 &Min,const D3DXVECTOR3 &Max)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);
	
	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);
	
	// GtFNgJn
	m_Effect.Begin();

	Vtx3D	v[16];

	v[0].x = Min.x;	v[0].y = Min.y;	v[0].z = Min.z;
	v[1].x = Max.x;	v[1].y = Min.y;	v[1].z = Min.z;
	v[2].x = Max.x;	v[2].y = Max.y;	v[2].z = Min.z;
	v[3].x = Min.x;	v[3].y = Max.y;	v[3].z = Min.z;
	v[4].x = Min.x;	v[4].y = Min.y;	v[4].z = Min.z;
	v[5].x = Min.x;	v[5].y = Min.y;	v[5].z = Max.z;
	v[6].x = Min.x;	v[6].y = Max.y;	v[6].z = Max.z;
	v[7].x = Min.x;	v[7].y = Max.y;	v[7].z = Min.z;

	v[8].x = Max.x;	v[8].y = Min.y;	v[8].z = Max.z;
	v[9].x = Min.x;	v[9].y = Min.y;	v[9].z = Max.z;
	v[10].x = Min.x;v[10].y = Max.y;v[10].z = Max.z;
	v[11].x = Max.x;v[11].y = Max.y;v[11].z = Max.z;
	v[12].x = Max.x;v[12].y = Min.y;v[12].z = Max.z;
	v[13].x = Max.x;v[13].y = Min.y;v[13].z = Min.z;
	v[14].x = Max.x;v[14].y = Max.y;v[14].z = Min.z;
	v[15].x = Max.x;v[15].y = Max.y;v[15].z = Max.z;

	for(int i = 0;i < sizeof(v)/sizeof(v[0]);++i)
		v[i].color = Color;

	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;
	// `P
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,7,v,sizeof(Vtx3D))))
		return false;
	// `Q
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,7,&v[8],sizeof(Vtx3D))))
		return false;
	
	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//-----------------------------------------------
//	`
//
//	F	pWorldMtx	[hϊs
//			Color		F
//			Pos			̒SW
//			R			̔a			
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawSphere(const D3DXMATRIX* pWorldMtx,DWORD Color,const D3DXVECTOR3 &Pos,float R)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);
	
	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);
	
	// GtFNgJn
	m_Effect.Begin();

	// _\̐錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;

	// x]s
	D3DXMATRIX RotXMtx;
	D3DXMatrixIdentity(&RotXMtx);
	// y]s
	D3DXMATRIX RotYMtx;
	D3DXMatrixIdentity(&RotYMtx);

	float divide = D3DX_PI/8;
	D3DXVECTOR3 vec[17];	
	Vtx3D v[17];

	D3DXVECTOR3 Translation = Pos;
	for(float phi = 0;phi < D3DX_PI;phi += divide)
	{
		// ~
		int count = 0;
		for(float theta = 0; theta <= D3DX_PI * 2 + divide;theta += divide)
		{
			vec[count].x = R * cosf(theta);
			vec[count].y = 0.0f;
			vec[count].z = R * sinf(theta);
			count++;
		}
		
		// ]
		for(int i = 0;i < ((D3DX_PI * 2) / divide + 1);++i)
		{
			D3DXVec3TransformCoord(&vec[i],&vec[i],&RotXMtx);
			v[i].x = vec[i].x + Translation.x;
			v[i].y = vec[i].y + Translation.y;
			v[i].z = vec[i].z + Translation.z;
			v[i].color = Color;
		}
		
		// `
		if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,16,v,sizeof(Vtx3D))))
			return false;		

	}

	for(float phi = 0;phi < D3DX_PI;phi += divide)
	{
		//~
		int count = 0;
		for(float theta = 0; theta <= D3DX_PI * 2 + divide;theta += divide)
		{
			vec[count].x = 0.0f;
			vec[count].y = R * sinf(theta);
			vec[count].z = R * cosf(theta);
			count++;
		}
		D3DXMatrixRotationY(&RotYMtx,phi);

		//]
		for(int i = 0;i < ((D3DX_PI * 2) / divide + 1);++i)
		{
			D3DXVec3TransformCoord(&vec[i],&vec[i],&RotYMtx);
			v[i].x = vec[i].x + Translation.x;
			v[i].y = vec[i].y + Translation.y;
			v[i].z = vec[i].z + Translation.z;
			v[i].color = Color;
		}

		//`
		if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,16,v,sizeof(Vtx3D))))
			return false;		

	}

	
	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}

//---------------------------------------------
//	JvZ`
//
//	F	pWorldMtx	[hϊs
//			Color		F
//			R			̔a			
//			Height		~̍
//
//	߂lF	true:	`搬
//			false:	`掸s
//--------------------------------------------
bool Geometory::DrawCapsule(const D3DXMATRIX* pWorldMtx,DWORD Color,float R,float Height)
{
	if(	m_Effect.GetEffect() == NULL){
		ASSERT_MSG(_T("􉽃IuWFNg`GtFNg쐬Ă܂\n"));
		return false;
	}
	// foCX擾
	IDirect3DDevice9* pD3DDevice = NULL;
	m_Effect.GetEffect()->GetDevice(&pD3DDevice);
	
	// eNjbNZbg
	m_Effect.SetTechnique(_T("T0"),PASS_DRAW3D);

	// GtFNgɕϊsZbg
	SetEffectParam(pWorldMtx);
	
	// GtFNgJn
	m_Effect.Begin();

	// _\̐錾Zbg	
	if(FAILED(pD3DDevice->SetVertexDeclaration(m_pVertexDecl3D)))
		return false;

	
	// y]s
	D3DXMATRIX RotYMtx;
	D3DXMatrixIdentity(&RotYMtx);

	// 2`
	const int div = 8;
	float divide = D3DX_PI/div;
	D3DXVECTOR3 vec[div + 1];	
	Vtx3D v[div + 1];
	int turn = 1;
	float phi = 0.0f;

	for(int k = 0;k < 2;++k)
	{
		phi = 0.0f;
		for(int j = 0;j <= div;++j)
		{
			// ~
			float theta = 0;
			for(int i = 0;i <= div;++i)
			{
				vec[i].x = 0.0f;
				vec[i].y = R * sinf(theta * turn);
				vec[i].z = R * cosf(theta * turn);
				theta += divide;
			}
			D3DXMatrixRotationY(&RotYMtx,phi);
			phi += divide;

			// ]
			for(int i = 0;i <= div;++i)
			{
				D3DXVec3TransformCoord(&vec[i],&vec[i],&RotYMtx);
				v[i].x = vec[i].x;
				v[i].y = vec[i].y + Height/2.0f * turn;
				v[i].z = vec[i].z;
				v[i].color = Color;
			}

			// `
			if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,div,v,sizeof(Vtx3D))))
				return false;

		}
		turn *= -1;
	}
	
	
	// ~`
	
	// ~`
	Vtx3D circlev[div * 2 + 1];
	turn = 1;
	for(int k = 0;k < 2;++k)
	{
		phi = 0.0f;
		for(int i = 0;i <= div * 2;++i)
		{
			circlev[i].x = R * sinf(phi);
			circlev[i].y = Height/2.0f * turn;
			circlev[i].z = R * cosf(phi);
			circlev[i].color = Color;
			phi += divide;
		}
		// `
		if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINESTRIP,div * 2,circlev,sizeof(Vtx3D))))
			return false;

		turn *= -1;
	}

	// `
	Vtx3D polev[div * 4];
	phi = 0.0f;
	for(int i = 0;i < div * 4;i += 2)
	{
		polev[i].x = R * sinf(phi);
		polev[i].y = Height/2.0f;
		polev[i].z = R * cosf(phi);
		polev[i].color = Color;
		
		polev[i + 1].x = R * sinf(phi);
		polev[i + 1].y = -Height/2.0f;
		polev[i + 1].z = R * cosf(phi);
		polev[i + 1].color = Color;

		phi += divide;
	}
	// `
	if(FAILED(pD3DDevice->DrawPrimitiveUP(D3DPT_LINELIST,div * 2,polev,sizeof(Vtx3D))))
		return false;
	
	// GtFNgI
	m_Effect.End();	
	SafeRelease(pD3DDevice);
	return true;
}