
#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "directshow.h"
#include "drawer.h"
#include "debugcamera.h"

class WindowEx : public Window
{
private:
	Direct3D9		m_Direct3D9;
	DirectInput		m_DirectInput;
	DirectShow		m_Video;
	Texture			m_Texture;
	BillBoard		m_BillBoard;
	DebugCamera		m_Camera;
	
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());

		// rfI
		m_Video.LoadVideo(_T("test.avi"));
		// J
		//m_Video.Capture();		
		m_Video.Play();
		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		

		// _[eNX`쐬
		m_Texture.Create(m_Direct3D9.GetDevice(),m_Video.GetWidth(),m_Video.GetHeight(),false);
		// r{[h쐬		
		m_BillBoard.Create(m_Direct3D9.GetDevice(),m_Video.GetWidth()/8,m_Video.GetHeight()/8,D3DXVECTOR3(0,0,0));
		// UV㉺]
		m_BillBoard.SetTurnV(true);

		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		// rfIeNX`쐬
		m_Video.GetBuffer((long*)m_Texture.Lock()->pBits);
		m_Texture.UnLock();

		if(m_Direct3D9.BeginScene()){

			// XN[hԂ
			m_Direct3D9.ScreenClear(0xff808080);


			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);

			// r{[h`
			Drawer::DrawPlanePolygon(m_BillBoard,m_Texture);

			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}