// ---------------------------------------------------------------
//	Tv:			DirectSound֌W
//	t@C:		DirectSound.h
//
//	쐬	Daiki Terai
//	쐬	2009/12/22
//	C	
// ---------------------------------------------------------------

#include "directsound.h"

//----------------------------------------------
//	RXgN^
//----------------------------------------------
DirectSound::DirectSound()
:m_pDirectSound8(NULL),m_pListener(NULL)
{
	memset(&m_DSCaps,0,sizeof(DSCAPS));
}

//----------------------------------------------
//	fXgN^
//----------------------------------------------
DirectSound::~DirectSound()
{
	// Xi[폜
	SafeRelease(m_pListener);
	// DirectSoundIuWFNg̉
	SafeRelease(m_pDirectSound8);
}


// ---------------------------------------------------------------
//	DirectSound
//
//					hWnd				EBhEnh
//
//	߂l			true				
//					false				s
// ---------------------------------------------------------------
bool DirectSound::Create(HWND hWnd)
{
	// 쐬ς݂ł΁AĂэKv͂Ȃ
	if(m_pDirectSound8)
		return true;

	// ftHg̃TEhfoCXg
	if (FAILED(DirectSoundCreate8(NULL/*DSDEVID_DefaultPlayback*/, &m_pDirectSound8, NULL)))
	{
		return false;
	}

	
	// x
	if (FAILED(m_pDirectSound8->SetCooperativeLevel(hWnd, DSSCL_PRIORITY)))
	{
		// s
		return false;
	}

	// TEhfoCX̐\
	m_DSCaps.dwSize = sizeof(DSCAPS);	// KdwSizeo
	if(FAILED(m_pDirectSound8->GetCaps(&m_DSCaps)))
	{
		// 擾s
		OutputDebugString(_T("SoundDevice Caps Error"));
	}

	// Xi[쐬
	DSBUFFERDESC            desc = {};
	LPDIRECTSOUNDBUFFER     pPrimaryBuffer;  
	desc.dwSize = sizeof(DSBUFFERDESC);
	desc.dwFlags = DSBCAPS_CTRL3D | DSBCAPS_PRIMARYBUFFER ;
	if (FAILED(m_pDirectSound8->CreateSoundBuffer(&desc, &pPrimaryBuffer, NULL)))
		return false;
	if(FAILED(pPrimaryBuffer->QueryInterface(IID_IDirectSound3DListener8, (void**)&m_pListener)))
	{
		SafeRelease(pPrimaryBuffer);
		return false;
	}
	SafeRelease(pPrimaryBuffer);

	
	// I
	//atexit(DirectSound::Release);

	return true;
}


//--------------------------------------------
//	TEhfoCX̎擾
//
//		Ȃ
//	
//	߂l	DirectSound
//--------------------------------------------
LPDIRECTSOUND8 DirectSound::GetDevice()
{
	return m_pDirectSound8;
}



//-----------------------------------------------------------------
// Xi[ʒuA̐ݒ
//	
//			Pos			ʒuxNg
//			Dir			ÕxNg
//			Up			AbvxNg
//
//	߂l	Ȃ
//-----------------------------------------------------------------
void DirectSound::SetPosDir(const D3DXVECTOR3& Pos,const D3DXVECTOR3& Dir,const D3DXVECTOR3& Up)
{
	m_pListener->SetPosition(Pos.x,Pos.y,Pos.z,DS3D_IMMEDIATE);
	m_pListener->SetOrientation(Dir.x,Dir.y,Dir.z,Up.x,Up.y,Up.z,DS3D_IMMEDIATE);
}

//------------------------------------------------------------------
//	[ItiXi[ARcԂ̋ɂ鉹̌j̐ݒ
//
//			flRolloffFactor		[Itli0.0f`10.0f̒lj
//			
//	߂l	Ȃ
//------------------------------------------------------------------
void DirectSound::SetRolloff(float flRolloffFactor)
{
	if(flRolloffFactor < 0.0f)
		flRolloffFactor = 0.0f;

	if(flRolloffFactor > 10.0f)
		flRolloffFactor = 10.0f;

	m_pListener->SetRolloffFactor(flRolloffFactor,DS3D_IMMEDIATE);
}