#define _CRT_SECURE_NO_WARNINGS
#include "Effect.h"

// eNjbNnh擾
void Effect::GetTechniques()
{

	D3DXEFFECT_DESC EffectDesc = {};
	D3DXTECHNIQUE_DESC TechniqueDesc = {};
	D3DXHANDLE hTechnique = NULL;

	// GtFNg擾
	m_pEffect->GetDesc( &EffectDesc );

	// ݂̃eNjbN擾
	m_hCurrentTechnique = m_pEffect->GetCurrentTechnique();
	
	// eNjbN̎擾
	for(DWORD i = 0;i < EffectDesc.Techniques;i++)
	{
		// eNjbNnh擾
		hTechnique = m_pEffect->GetTechnique( i);
		// eNjbN擾
		m_pEffect->GetTechniqueDesc(hTechnique, &TechniqueDesc);

		TCHAR tTechniqueName[MAX_PATH] = {};
#ifdef UNICODE
		mbstowcs(tTechniqueName,TechniqueDesc.Name,strlen(TechniqueDesc.Name));
#else
		_tcscpy(tTechniqueName,TechniqueDesc.Name);
#endif
		
		if( TechniqueDesc.Name != NULL )
		{
#ifdef _DEBUG
			m_Techniques.insert(std::make_pair(tTechniqueName,TechniqueDesc));
#endif
			m_hTechniques.insert(std::make_pair(tTechniqueName,hTechnique));
		}
	
	}
} 
// VF[_ϐnh擾
void Effect::GetParams()
{

	D3DXEFFECT_DESC EffectDesc = {};
	D3DXPARAMETER_DESC ParamDesc = {};
	D3DXHANDLE hParam = NULL;

	// GtFNg擾
	m_pEffect->GetDesc( &EffectDesc );

	
	// VF[_O[oϐ̎擾
	for(DWORD i = 0;i < EffectDesc.Parameters;i++)
	{
		// VF[_O[oϐnh擾
		hParam = m_pEffect->GetParameter(NULL, i);
		// VF[_O[oϐ̏擾
		m_pEffect->GetParameterDesc(hParam, &ParamDesc);

		TCHAR tParamName[MAX_PATH] = {};
#ifdef UNICODE
		mbstowcs(tParamName,ParamDesc.Name,strlen(ParamDesc.Name));
#else
		_tcscpy(tParamName,ParamDesc.Name);
#endif
		
		if( ParamDesc.Name  != NULL )
		{
#ifdef _DEBUG
			m_Params.insert(std::make_pair(tParamName,ParamDesc));
#endif
			m_hParams.insert(std::make_pair(tParamName,hParam));		
		}
	
	}
}

// RXgN^
Effect::Effect():m_pEffect(NULL),m_ID(0),m_hCurrentTechnique(NULL),m_CurrentPass(0)
{}

// Rs[RXgN^
Effect::Effect(const Effect& obj){
	this->Clone(&obj);
}
// Zq̃I[o[[h
Effect& Effect::operator=(const Effect& obj)
{
	this->Clone(&obj);
	return *this;
}
// Rs[(deep copy)
bool Effect::Clone(const Effect* pEffect)
{
	if(pEffect->m_pEffect == NULL)
		return false;

	IDirect3DDevice9* pD3DDevice = NULL;
	// foCX̎擾
	pEffect->m_pEffect->GetDevice(&pD3DDevice);
	// GtFNg̃Rs[
	pEffect->m_pEffect->CloneEffect(pD3DDevice,&m_pEffect);
	SafeRelease(pD3DDevice);
	// VF[_擾
	this->GetTechniques();
	this->GetParams();
	m_CurrentPass = pEffect->m_CurrentPass;
	return true;
}

// fXgN^
Effect::~Effect()
{
	m_hParams.clear();
	m_hTechniques.clear();
	SafeRelease(m_pEffect);
}


// t@CGtFNg쐬
bool Effect::Create(IDirect3DDevice9* pD3DDevice,const TCHAR* FXFileName)
{
	// łɍ쐬Ă玸s
	if(m_pEffect != NULL)
		return false;

	LPD3DXBUFFER pError = NULL;
	// GtFNg쐬
#ifdef _DEBUG
	HRESULT hr = D3DXCreateEffectFromFileEx(pD3DDevice, FXFileName, NULL, NULL, NULL,D3DXSHADER_DEBUG, NULL, &m_pEffect, &pError);
#else
	HRESULT hr = D3DXCreateEffectFromFileEx(pD3DDevice, FXFileName, NULL, NULL, NULL,D3DXSHADER_SKIPVALIDATION, NULL, &m_pEffect, &pError);
#endif

	// 쐬s
	if (FAILED(hr))
	{
		::OutputDebugStringA(static_cast<char*>(pError->GetBufferPointer()));
		::OutputDebugString(_T("\n"));
		ASSERT_MSG(_T("VF[_[RpCG[\n"));
		return false;
	}

	// VF[_擾
	this->GetTechniques();
	this->GetParams();

	// GtFNg
	m_Name = FXFileName;

	return true;
}

// \[XGtFNg쐬
bool Effect::Create(IDirect3DDevice9* pD3DDevice,int ResourceID)
{
	// łɍ쐬Ă玸s
	if(m_pEffect != NULL)
		return false;

	LPD3DXBUFFER pError = NULL;
	// GtFNg쐬
#ifdef _DEBUG
	HRESULT hr = D3DXCreateEffectFromResourceEx(pD3DDevice,NULL,MAKEINTRESOURCE(ResourceID), NULL, NULL, NULL,D3DXSHADER_DEBUG, NULL, &m_pEffect, &pError);
#else
	HRESULT hr = D3DXCreateEffectFromResourceEx(pD3DDevice,NULL,MAKEINTRESOURCE(ResourceID), NULL, NULL, NULL,D3DXSHADER_SKIPVALIDATION, NULL, &m_pEffect, &pError);
#endif

	// 쐬s
	if (FAILED(hr))
	{
		::OutputDebugStringA(static_cast<char*>(pError->GetBufferPointer()));
		::OutputDebugString(_T("\n"));
		ASSERT_MSG(_T("VF[_[RpCG[\n"));
		return false;
	}
		
	// VF[_擾
	this->GetTechniques();
	this->GetParams();

	// GtFNgID
	m_ID = ResourceID;

	return true;
}


// GtFNg|C^擾
ID3DXEffect* Effect::GetEffect(){
	return m_pEffect;
}



// VF[_O[oϐ`FbN
bool Effect::IsParamName(const TCHAR* ParamName){
	if(m_hParams.find(ParamName) == m_hParams.end()){
		ASSERT_MSG(_T("VF[_ϐ݂܂"));	
		return false;
	}

	return true;
}

// sZbg
bool Effect::SetMatrix(const TCHAR* ParamName,const D3DXMATRIX* pMtx){

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetMatrix(m_hParams[ParamName],pMtx))){
			ASSERT_MSG(_T("VF[_sϐZbgs"));
			return false;
		}
	}

	return true;
}

// spbgZbg
bool Effect::SetMatrixArray(const TCHAR* ParamName,const D3DXMATRIX* pMtxArray,int Count){

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetMatrixArray(m_hParams[ParamName],pMtxArray,Count))){
			ASSERT_MSG(_T("VF[_spbgϐZbgs"));
			return false;
		}
	}

	return true;
}

// 4xNgZbg
bool Effect::SetVector4(const TCHAR* ParamName,const D3DXVECTOR4* pVec4){

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetVector(m_hParams[ParamName],pVec4))){
			ASSERT_MSG(_T("VF[_SxNgϐZbgs"));
			return false;
		}
	}

	return true;
}

// 3xNg̃Zbg
bool Effect::SetVector3(const TCHAR* ParamName,const D3DXVECTOR3* pVec3)
{

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetFloatArray( m_hParams[ParamName], &pVec3->x, 3 ))){
			ASSERT_MSG(_T("VF[_RxNgZbgs"));
			return false;
		}
	}

	return true;
}

// Zbg
bool Effect::SetFloat(const TCHAR* ParamName,float Param){

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetFloat(m_hParams[ParamName],Param))){
			ASSERT_MSG(_T("VF[_ϐZbgs"));
			return false;
		}
	}

	return true;
}

// ̃Zbg
bool Effect::SetInt(const TCHAR* ParamName,int Param)
{

#ifdef _DEBUG
	if(this->IsParamName(ParamName))
#endif
	{
		if(FAILED(m_pEffect->SetInt(m_hParams[ParamName],Param))){
			ASSERT_MSG(_T("VF[_ϐZbgs"));
			return false;
		}
	}

	return true;
}

// eNX`Zbg
bool Effect::SetTexture(const TCHAR* TextureName,IDirect3DBaseTexture9* pTexture){

#ifdef _DEBUG
	if(this->IsParamName(TextureName))
#endif
	{
		if(FAILED(m_pEffect->SetTexture(m_hParams[TextureName],pTexture))){
			ASSERT_MSG(_T("eNX`Zbgs"));
			return false;
		}
	}

	return true;
}

// eNjbÑZbg
bool Effect::SetTechnique(const TCHAR* TechniqueName,UINT Pass)
{
	// eNjbN̕ύXꍇ
	if(m_hTechniques[TechniqueName] != m_hCurrentTechnique){
		// eNjbÑZbg
		if(FAILED(m_pEffect->SetTechnique(m_hTechniques[TechniqueName]))){ 
			ASSERT_MSG(_T("w̃eNjbN݂܂\n")); 
			return false;
		}
		// ݂̃eNjbN擾
		m_hCurrentTechnique = m_pEffect->GetCurrentTechnique();
	}
	// pX̃Zbg
	m_CurrentPass = Pass;

	return true;
}

// GtFNgJn
bool Effect::Begin(){

#ifdef _DEBUG
	if(m_pEffect == NULL)
		return false;
#endif


	UINT PassNum;
	m_pEffect->Begin(&PassNum, 0);
	// pXZbg
	if(FAILED(m_pEffect->BeginPass(m_CurrentPass))){ 
		ASSERT_MSG(_T("w̃pX݂܂\n")); 
		return false;
	}
	// VF[_ϐ̒lK
	m_pEffect->CommitChanges();

	return true;
}


// GtFNgI
bool Effect::End(){
	
#ifdef _DEBUG
	if(m_pEffect == NULL)
		return false;
#endif

	// VF[_vȌI錾
	m_pEffect->EndPass();
	m_pEffect->End();			

	return true;
}