
#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "directsound.h"
#include "drawer.h"
#include "debugcamera.h"
#include "soundbuffer.h"

class WindowEx : public Window
{
private:
	Direct3D9		m_Direct3D9;
	DirectInput		m_DirectInput;
	DirectSound		m_DirectSound;
	DebugCamera		m_Camera;
	SoundBuffer		m_BGMBuf;
	SoundBuffer		m_SEBuf;
	Wave			m_BGM;
	Wave			m_SE;
	
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// TEhfoCX쐬
		m_DirectSound.Create(hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());

		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		

		// Wavet@C[h
		m_BGM.Load(_T("BGM.wav"));

		m_SE.Load(_T("SE.wav"));
		m_BGMBuf.Create(m_DirectSound.GetDevice(),m_BGM);
		m_SEBuf.Create(m_DirectSound.GetDevice(),m_SE,true);
		m_SEBuf.Set3DSoundMode(DS3DMODE_NORMAL);

		
		m_BGMBuf.Play(true);
		
		// 3D̐ݒ
		m_SEBuf.Set3DSoundDistance(50,1000);
		m_SEBuf.Set3DSoundPos(D3DXVECTOR3(0,0,0));
		m_SEBuf.Set3DSoundCone();
		// 3Ď
		m_DirectSound.SetRolloff(1.0f);
		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());
		// Xi[̍XV
		m_DirectSound.SetPosDir(m_Camera.GetEye(),m_Camera.GetDirection(),m_Camera.GetUp());

		static int vol = -1000;
		static int pan = 0;
		if(m_DirectInput.GetKeyInputState(DIK_W) == INPUTSTATE_PUSH && vol <= DSBVOLUME_MAX)
			vol+= 100;
		if(m_DirectInput.GetKeyInputState(DIK_S) == INPUTSTATE_PUSH && vol >= DSBVOLUME_MIN)
			vol-= 100;
		if(m_DirectInput.GetKeyInputState(DIK_A) == INPUTSTATE_PUSH && pan >= DSBPAN_LEFT)
			pan-= 100;
		if(m_DirectInput.GetKeyInputState(DIK_D) == INPUTSTATE_PUSH && pan <= DSBPAN_RIGHT)
			pan+= 100;
		m_BGMBuf.SetSoundVolume(vol);
		m_BGMBuf.SetSoundPan(pan);
		
		if(m_SEBuf.IsStop())
		{
			m_SEBuf.Play();
		}

		if(m_Direct3D9.BeginScene()){

			// XN[hԂ
			m_Direct3D9.ScreenClear(0xff808080);


			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);
			Drawer::DrawSphere();


			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}