#include "object3d.h"

// r[ϊs
D3DXMATRIX Object3D::m_ViewMtx;
// ˉeϊs
D3DXMATRIX Object3D::m_ProjMtx;

//-------------------------//
// RXgN^
//-------------------------//
Object3D::Object3D()
	:m_Dir(0.0f,0.0f,-1.0f),m_Scale(1.0f,1.0f,1.0f),m_Translate(0,0,0)
{
	D3DXMatrixIdentity(&m_RotateMtx);
	D3DXMatrixIdentity(&m_WorldMtx);
}

//-------------------------//
// fXgN^
//-------------------------//
Object3D::~Object3D()
{}

//-------------------------------------------//
//	[hϊsZbg
//
//	F	WorldMtx	[hϊs
//-------------------------------------------//
void Object3D::SetWorldMatrix(const D3DXMATRIX& WorldMtx)
{
	m_WorldMtx = WorldMtx;

	// vZScale * Rotate * Translation̏ԂɂȂĂs񂪑Oł
	// ȊO̍s񂩂͌̐ZołȂ


	// XP[O擾
	D3DXVECTOR3 Sx(WorldMtx._11,WorldMtx._12,WorldMtx._13);
	D3DXVECTOR3 Sy(WorldMtx._21,WorldMtx._22,WorldMtx._23);
	D3DXVECTOR3 Sz(WorldMtx._31,WorldMtx._32,WorldMtx._33);
	D3DXVECTOR3 Scale(D3DXVec3Length(&Sx),D3DXVec3Length(&Sy),D3DXVec3Length(&Sz));
	m_Scale = Scale;

	// sړ擾
	m_Translate.x = WorldMtx._41;
	m_Translate.y = WorldMtx._42;
	m_Translate.z = WorldMtx._43;

	// ]s擾
	m_RotateMtx._11 = WorldMtx._11 / Scale.x;
	m_RotateMtx._12 = WorldMtx._12 / Scale.x;
	m_RotateMtx._13 = WorldMtx._13 / Scale.x;
	m_RotateMtx._14 = 0.0f;
	m_RotateMtx._21 = WorldMtx._21 / Scale.y;
	m_RotateMtx._22 = WorldMtx._22 / Scale.y;
	m_RotateMtx._23 = WorldMtx._23 / Scale.y;
	m_RotateMtx._24 = 0.0f;
	m_RotateMtx._31 = WorldMtx._31 / Scale.z;
	m_RotateMtx._32 = WorldMtx._32 / Scale.z;
	m_RotateMtx._33 = WorldMtx._33 / Scale.z;
	m_RotateMtx._34 = 0.0f;
	m_RotateMtx._41 = 0.0f;
	m_RotateMtx._42 = 0.0f;
	m_RotateMtx._43 = 0.0f;
	m_RotateMtx._44 = 1.0f;

}

//--------------------------------------------//
//	[hϊs擾
//
//	߂lF[hϊs
//--------------------------------------------//
const D3DXMATRIX& Object3D::GetWorldMatrix() const
{
	return m_WorldMtx;
}

//--------------------------------------------//
//	[hϊs쐬
//--------------------------------------------//
void Object3D::CreateWorldMatrix(){
	D3DXMATRIX ScaleMtx,RotateMtx,TranslateMtx;
	D3DXMatrixScaling(&ScaleMtx,m_Scale.x,m_Scale.y,m_Scale.z);
	D3DXMatrixTranslation(&TranslateMtx,m_Translate.x,m_Translate.y,m_Translate.z);
	m_WorldMtx = ScaleMtx * m_RotateMtx * TranslateMtx;
}



//-------------------------------------------//
//	r[ϊsZbg
//
//	FViewMtx r[ϊs
//-------------------------------------------//
void Object3D::SetViewMtx(const D3DXMATRIX& ViewMtx)
{
	m_ViewMtx = ViewMtx;
}
//--------------------------------------------//
//	r[ϊs擾
//
//	߂lFr[ϊs
//--------------------------------------------//
const D3DXMATRIX& Object3D::GetViewMatrix() 
{
	return m_ViewMtx;
}


//-------------------------------------------//
//	ˉeϊsZbg
//
//	FProjMtx ˉeϊs
//-------------------------------------------//
void Object3D::SetProjMtx(const D3DXMATRIX& ProjMtx)
{
	m_ProjMtx = ProjMtx;
}
//--------------------------------------------//
//	ˉeϊs擾
//
//	߂lFˉeϊs
//--------------------------------------------//
const D3DXMATRIX& Object3D::GetProjMatrix() 
{
	return m_ProjMtx;
}

//////////////////////////////////////////////////////////////////

//-----------------------------------//
//	XP[OZbg
//
//	FScale	XP[O
//-----------------------------------//
void Object3D::SetScale(const D3DXVECTOR3& Scale){
	m_Scale = Scale;
}
//-----------------------------------//
//	XP[OZbg
//
//	Fx,y,z	eɑ΂XP[O
//-----------------------------------//
void Object3D::SetScale(float x,float y,float z){
	m_Scale.x = x;
	m_Scale.y = y;
	m_Scale.z = z;
}

//-----------------------------------//
//	]Zbg
//
//	FRotate ]
//-----------------------------------//
void Object3D::SetRotate(const D3DXVECTOR3& Rotate){
	D3DXMatrixRotationYawPitchRoll(&m_RotateMtx,Rotate.y,Rotate.x,Rotate.z);
}
//-----------------------------------//
//	]Zbg
//
//	Fx,y,z	eɑ΂]
//-----------------------------------//
void Object3D::SetRotate(float x,float y,float z){
	D3DXMatrixRotationYawPitchRoll(&m_RotateMtx,y,x,z);
}
//-----------------------------------//
//	sړZbg
//
//	FTranslate sړ
//-----------------------------------//
void Object3D::SetTranslate(const D3DXVECTOR3& Translate){
	m_Translate = Translate;
}
//-----------------------------------//
//	sړZbg
//
//	Fx,y,z	eɑ΂镽sړ
//-----------------------------------//
void Object3D::SetTranslate(float x,float y,float z){
	m_Translate.x = x;
	m_Translate.y = y;
	m_Translate.z = z;
}

//////////////////////////////////////////////////////////////////


//-----------------------------------//
//	XP[OXV
//
//	FScale	XP[O
//-----------------------------------//
void Object3D::UpdateScale(const D3DXVECTOR3& Scale)
{
	m_Scale += Scale;
}
//-----------------------------------//
//	XP[OXV
//
//	Fx,y,z	eɑ΂XP[O
//-----------------------------------//
void Object3D::UpdateScale(float x,float y,float z)
{
	m_Scale.x += x;
	m_Scale.y += y;
	m_Scale.z += z;
}

//-----------------------------------//
//	]XV
//
//	FRotate ]
//-----------------------------------//
void Object3D::UpdateRotate(const D3DXVECTOR3& Rotate)
{
	D3DXMATRIX RotateMtx;
	D3DXMatrixRotationYawPitchRoll(&RotateMtx,Rotate.y,Rotate.x,Rotate.z);
	m_RotateMtx = RotateMtx * m_RotateMtx;
}
//-----------------------------------//
//	]XV
//
//	Fx,y,z	eɑ΂]
//-----------------------------------//
void Object3D::UpdateRotate(float x,float y,float z)
{
	D3DXMATRIX RotateMtx;
	D3DXMatrixRotationYawPitchRoll(&RotateMtx,y,x,z);
	m_RotateMtx = RotateMtx * m_RotateMtx;
}

//-----------------------------------//
//	sړXV
//
//	FTranslate sړ
//-----------------------------------//
void Object3D::UpdateTranslate(const D3DXVECTOR3& Translate)
{
	m_Translate += Translate;
}
//-----------------------------------//
//	sړXV
//
//	Fx,y,z	eɑ΂镽sړ
//-----------------------------------//
void Object3D::UpdateTranslate(float x,float y,float z)
{
	m_Translate.x += x;
	m_Translate.y += y;
	m_Translate.z += z;
}


//////////////////////////////////////////////////////////////////


//-----------------------------------//
//	XP[O擾
//
//	߂lFXP[O
//-----------------------------------//
const D3DXVECTOR3& Object3D::GetScale() const{
	return m_Scale;
}
//-----------------------------------//
//	]擾
//
//	߂lF]
//-----------------------------------//
const D3DXMATRIX& Object3D::GetRotateMatrix() const{
	return m_RotateMtx;
}
//-----------------------------------//
//	sړ擾
//
//	߂lFsړ
//-----------------------------------//
const D3DXVECTOR3& Object3D::GetTranslate() const{
	return m_Translate;
}

//////////////////////////////////////////////////////////////////

//--------------------------------------------//
//	f̐ʌZbg
//
//	FDir ʌ
//--------------------------------------------//
void Object3D::SetDir(const D3DXVECTOR3& Dir)
{
	m_Dir = Dir;
}

//--------------------------------------------//
//	f̐ʌ擾
//
//	߂lFʌ
//--------------------------------------------//
D3DXVECTOR3 Object3D::GetDir()
{
	D3DXVECTOR3 Dir;
	D3DXVec3TransformCoord(&Dir,&m_Dir,&m_RotateMtx);
	return Dir;
}