#include "soundbuffer.h"

// RXgN^
SoundBuffer::SoundBuffer()
	:m_pDS8SoundBuffer(NULL),
	m_pDS8Sound3DBuffer(NULL)
{}

// fXgN^
SoundBuffer::~SoundBuffer()
{
	if(m_pDS8SoundBuffer != NULL)
		this->Stop();
		
	SafeRelease(m_pDS8SoundBuffer);
	SafeRelease(m_pDS8Sound3DBuffer);
}


//----------------------------------------------------------------------------------
//	TEhǂݍ	
//
//	F			pDirectSound8		DirectSoundIuWFNg
//					wave				Wavef[^
//					is3DSound			3DtO
//					Guid				̃ASY
//
//	GUID:			DS3DALG_NO_VIRTUALIZATION	ő̃ASY
//					DS3DALG_HRTF_LIGHT			botD悷ASY
//					DS3DALG_HRTF_FULL			̃ASY
//----------------------------------------------------------------------------------
bool SoundBuffer::Create(IDirectSound8* pDirectSound8,Wave& wave,bool is3DSound,GUID Guid)
{

	DSBUFFERDESC desc;
	::memset(&desc, 0, sizeof(DSBUFFERDESC));
	desc.dwSize	= sizeof(DSBUFFERDESC);

	// `lł̕Am1`lAXeI2`l
	// 3D̓mȂ̂Œ
	if(wave.GetFormat()->nChannels == 1)	desc.dwFlags =  DSBCAPS_CTRL3D | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY | DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_STATIC;	// 3Dp̐ݒ͂łȂ
	else									desc.dwFlags =  DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY | DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_CTRLPAN | DSBCAPS_STATIC;  // | DSBCAPS_CTRLFX;	GtFNgǉ Duplicate łȂ

	desc.dwBufferBytes		= wave.GetDataSize();	// obt@TCYw
	desc.dwReserved			= 0;
	desc.lpwfxFormat		= wave.GetFormat();		// tH[}bgw(3DXeItH[}bgs)

	if(wave.GetFormat()->nChannels == 1)	desc.guid3DAlgorithm	= Guid;
	else									desc.guid3DAlgorithm	= GUID_NULL;	// 3D̃ASY͎gȂ


	IDirectSoundBuffer*	pPrimaryBuffer = NULL;	// vC}obt@
	if(pDirectSound8->CreateSoundBuffer(&desc,&pPrimaryBuffer,NULL))
		return false;
	// TEhobt@쐬
	if (FAILED(pPrimaryBuffer->QueryInterface(IID_IDirectSoundBuffer8, (void**)&m_pDS8SoundBuffer))){
		SafeRelease(pPrimaryBuffer);
		return false;
	}
	SafeRelease(pPrimaryBuffer);

	// f[^TEhobt@ɏ
	unsigned char* block1		= NULL;
	unsigned char* block2		= NULL;
	unsigned long blockSize1	= 0;
	unsigned long blockSize2	= 0;

	// TEhobt@bN
	if (m_pDS8SoundBuffer->Lock(0, wave.GetDataSize(), (void**)&block1, &blockSize1, (void**)&block2, &blockSize2, DSBLOCK_ENTIREBUFFER) 
		== DSERR_BUFFERLOST)
	{
		// Xgꍇ̓XgA
		m_pDS8SoundBuffer->Restore();
		// TEhobt@bN
		if (FAILED(m_pDS8SoundBuffer->Lock(0, wave.GetDataSize(), (void**)&block1, &blockSize1, (void**)&block2, &blockSize2, DSBLOCK_ENTIREBUFFER)))
		{
			// s
			SafeRelease(m_pDS8SoundBuffer);
			return false;
		}
	}

	// f[^Rs[
	::memcpy(block1, wave.GetData(), wave.GetDataSize());
	// TEhobt@AbN
	m_pDS8SoundBuffer->Unlock(block1, blockSize1, block2, 0);



	// 3DTEh
	if(is3DSound){
		if (FAILED(m_pDS8SoundBuffer->QueryInterface(IID_IDirectSound3DBuffer8, (void**)&m_pDS8Sound3DBuffer)))
		{
			MessageBox(NULL,_T("3DTEhɎs܂BmmFĂ"),NULL,MB_OK);
			return false;
		}
		this->Set3DSoundMode(DS3DMODE_NORMAL);
	}

	return true;
}

//	TEhobt@(N[)쐬
//	ӁFGtFNgʃtO(DSBCAPS_CTRLFX)͕łȂ	
bool SoundBuffer::Create(IDirectSound8* pDirectSound8,IDirectSoundBuffer8* pDS8SoundBuffer,bool is3DSound)
{

	if( FAILED(pDirectSound8->DuplicateSoundBuffer(pDS8SoundBuffer,(LPDIRECTSOUNDBUFFER*)&m_pDS8SoundBuffer))){
		return false;
	}
	// 3DTEh
	if(is3DSound){
		if (FAILED(m_pDS8SoundBuffer->QueryInterface(IID_IDirectSound3DBuffer8, (void**)&m_pDS8Sound3DBuffer)))
		{
			MessageBox(NULL,_T("3DTEhɎs܂BmmFĂ"),NULL,MB_OK);
			return false;
		}
		this->Set3DSoundMode(DS3DMODE_NORMAL);

	}

	return true;
}

//	TEhobt@擾
IDirectSoundBuffer8* SoundBuffer::GetSoundBuffer()
{
	return m_pDS8SoundBuffer;
}

// TEhĐ
void SoundBuffer::Play(bool isLoop)
{
	isLoop ? m_pDS8SoundBuffer->Play(0,0,DSBPLAY_LOOPING) : m_pDS8SoundBuffer->Play(0,0,0);
}
// TEh~
void SoundBuffer::Stop()
{
	m_pDS8SoundBuffer->Stop();
}
// TEh~Ă邩H
bool SoundBuffer::IsStop()
{
	DWORD flag = 0;
	m_pDS8SoundBuffer->GetStatus(&flag);

	// Đ
	if(flag & DSBSTATUS_PLAYING)
		return false;

	return true;
}
// Đʒu擾
DWORD SoundBuffer::GetCursorPos()
{
	DWORD Cursor = 0;
	m_pDS8SoundBuffer->GetCurrentPosition(&Cursor,NULL);
	return Cursor;
}

// ---------------------------------------------------------------
//	TEh̉ʁi{[jݒ
//
//	:	volume	{[î݁A̒li0`-10000jj
// ---------------------------------------------------------------
void SoundBuffer::SetSoundVolume(long volume)
{

	if(volume > DSBVOLUME_MAX)
		volume = DSBVOLUME_MAX;

	if(volume < DSBVOLUME_MIN)
		volume = DSBVOLUME_MIN;

	m_pDS8SoundBuffer->SetVolume(volume);
}

// -----------------------------------------------------------------------------
//	TEh̃piEXs[J[̉ʁjݒ
//
//	:	Pan		p̒l(i0`10000jFEAi0`-10000jF)
// -----------------------------------------------------------------------------
void SoundBuffer::SetSoundPan(long Pan)
{
	if(Pan < DSBPAN_LEFT)
		Pan = DSBPAN_LEFT;

	if(Pan > DSBPAN_RIGHT)
		Pan = DSBPAN_RIGHT;

	m_pDS8SoundBuffer->SetPan(Pan);
}



//------------------------------------------------------------------
//	RcTEh̃[hݒ
//
//			mode				DS3DMODE_NORMAL܂DS3DMODE_HEADRELATIVE܂DS3DMODE_DISABLEݒ
//
//			DS3DMODE_NORMAL			:́uʒuvuxvuv3DԓɂΒlƂĈ
//			DS3DMODE_HEADRELATIVE	:́uʒuvuxvuv̓Xi[ɑ΂鑊ΒlƂĈ
//			DS3DMODE_DISABLE		:3D𖳌
//
//	߂l	Ȃ
//------------------------------------------------------------------
void SoundBuffer::Set3DSoundMode(int mode)
{
	if(m_pDS8Sound3DBuffer == NULL)
		return;

	m_pDS8Sound3DBuffer->SetMode(mode,DS3D_IMMEDIATE);	
}

//------------------------------------------------------------------
//	RcTEḧʒu̐ݒ
//
//			Pos ʒu
//
//	߂l	Ȃ
//------------------------------------------------------------------
void SoundBuffer::Set3DSoundPos(const D3DXVECTOR3& Pos)
{
	if(m_pDS8Sound3DBuffer == NULL)
		return;

	m_pDS8Sound3DBuffer->SetPosition(Pos.x,Pos.y,Pos.z,DS3D_IMMEDIATE);
}

//------------------------------------------------------------------
//	RcTEh̍ŏƍő勗̐ݒ
//
//			Min	ŏi̋𒴂Ɖ̌n܂j
//			Max	ő勗i̋𒴂ƊSɉȂȂj
//
//	߂l	Ȃ
//------------------------------------------------------------------
void SoundBuffer::Set3DSoundDistance(float Min,float Max)
{
	if(m_pDS8Sound3DBuffer == NULL)
		return;

	m_pDS8Sound3DBuffer->SetMinDistance(Min,DS3D_IMMEDIATE);
	m_pDS8Sound3DBuffer->SetMaxDistance(Max,DS3D_IMMEDIATE);
}


//------------------------------------------------------------------
//	RcTEḧʒuAAR[AOR[̐ݒ
//
//			Dir					TEhR[̕xNg
//			InsideConeAngle		R[`px(ftHg360x)
//			OutsideConeAngle	OR[`px(ftHg360x)
//			OutsideVolume		OR[̌(ftHgȂ)
//
//	߂l	Ȃ
//------------------------------------------------------------------
void SoundBuffer::Set3DSoundCone(
								const D3DXVECTOR3& Dir,
								unsigned long InsideConeAngle,
								unsigned long OutsideConeAngle,
								long OutsideVolume)
{
	if(m_pDS8Sound3DBuffer == NULL)
		return;

	m_pDS8Sound3DBuffer->SetConeOrientation(Dir.x,Dir.y,Dir.z,DS3D_IMMEDIATE);
	m_pDS8Sound3DBuffer->SetConeAngles(InsideConeAngle,OutsideConeAngle,DS3D_IMMEDIATE);
	m_pDS8Sound3DBuffer->SetConeOutsideVolume(OutsideVolume,DS3D_IMMEDIATE);

}

