
#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "drawer.h"
#include "debugcamera.h"

// őƍŏ̊Ԃ̒l_ɕԂwp[֐
float Random(float min,float max)
{
	return ((float)rand() / (float)RAND_MAX) * (max - min) + min;
} 

class Snow : public PointSprite
{
public:
	// p[eBÑZbg
	virtual void SetParticle(LPPARTICLE v,int ParticleNum)
	{
		for(int i = 0; i < ParticleNum; i++){
			// |CgXvCg̏ʒu
			v[i].pos = D3DXVECTOR3( Random(-100,100), 100.0f, Random(-100,100));

			// |CgXvCg̃TCY
			v[i].psize = 1.0f; 

			// |CgXvCg̏xƕ
			v[i].dir.x =  0.0f;
			v[i].dir.y =  -5.0f;
			v[i].dir.z =  0.0f;

			// |CgXvCǧp
			v[i].life_time = Random(15.0f,20.0f);
			v[i].start_time = Random(0.0f,15.0f);
		}
	}
};

class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	DirectInput	m_DirectInput;
	Texture		m_Texture;
	DebugCamera	m_Camera;

	Snow		m_Snow;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());

		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		
		// eNX`[h
		m_Texture.Create(_T("snow.jpg"),m_Direct3D9.GetDevice());

		// 쐬
		m_Snow.Create(m_Direct3D9.GetDevice(),1000);
		m_Snow.SetAccel(D3DXVECTOR3(0,-0.2f,0));
		
		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		// XN[hԂ
		m_Direct3D9.ScreenClear(0xff808080);
		if(m_Direct3D9.BeginScene()){

			// _[Xe[g̕ύX
			SetRenderState(m_Direct3D9.GetDevice(),RENDER_DEFAULT);

			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);

			// _[Xe[g̕ύX
			SetRenderState(m_Direct3D9.GetDevice(),RENDER_ADD);

			m_Snow.AdvanceTime(0.1f);
			Drawer::DrawPointSprite(m_Snow,m_Texture);

			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}