#include "pointsprite.h"


// _\̐錾쐬
bool PointSprite::CreateVertexDeclaration(IDirect3DDevice9* pD3DDevice)
{
	if(m_pVertexDecl != NULL)
	{
		ASSERT_MSG(_T("_\̐錾łɑ݂Ă܂\n"));
		return false;
	}

	// _\̒`
	D3DVERTEXELEMENT9 decl[] = 
	{
		{ 0, 0,  D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
		{ 0, 12, D3DDECLTYPE_FLOAT1, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_PSIZE,	   0 },
		{ 0, 16, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0 },
		{ 0, 28, D3DDECLTYPE_FLOAT1, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 1 },
		{ 0, 32, D3DDECLTYPE_FLOAT1, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 2 },
		D3DDECL_END()
	};

	// _\̐錾쐬
	if(FAILED(pD3DDevice->CreateVertexDeclaration( decl, &m_pVertexDecl )))
	{
		ASSERT_MSG(_T("_\̐錾쐬Ɏs܂\n"));
		return false;
	}
	return true;
}

// _obt@쐬
bool PointSprite::CreateVertexBuffer(IDirect3DDevice9* pD3DDevice,int ParticleNum)
{
	// _obt@̍쐬
	if(m_pVertexBuf!= NULL){
		ASSERT_MSG(_T("_obt@ɑ݂Ă܂\n"));
		return false;
	}

	// _obt@쐬
	if(FAILED(pD3DDevice->CreateVertexBuffer(sizeof(PARTICLE) * ParticleNum, 0, 0, D3DPOOL_MANAGED, &m_pVertexBuf, NULL)))
	{
		ASSERT_MSG(_T("_obt@쐬Ɏs܂\n"));
		return false;
	}
	return true;
}

// obt@쐬
bool PointSprite::CreateBuffer(IDirect3DDevice9* pD3DDevice,int ParticleNum)
{
	// _\̐錾쐬
	if(!this->CreateVertexDeclaration(pD3DDevice))
		return false;
	// _obt@쐬
	if(!this->CreateVertexBuffer(pD3DDevice,ParticleNum))
		return false;

	LPPARTICLE v;	// p[eBN_	
	m_pVertexBuf->Lock(0, 0, (void**)&v, 0);

	// p[eBÑZbg
	this->SetParticle(v,ParticleNum);

	m_pVertexBuf->Unlock();

	m_ParticleNum = ParticleNum;
	return true;
}

// sXV
void PointSprite::Update(IDirect3DDevice9* pD3DDevice)
{
	D3DVIEWPORT9 ViewPort;
	pD3DDevice->GetViewport(&ViewPort);
	m_ViewportHeight = (float)ViewPort.Height;

	// [hϊs
	this->CreateWorldMatrix();
}
// obt@Zbg
bool PointSprite::SetBuffer(IDirect3DDevice9* pD3DDevice)
{
	// _錾Zbg
	if(FAILED(pD3DDevice->SetVertexDeclaration( m_pVertexDecl ))){
		ASSERT_MSG(_T("_\̐錾쐬Ă܂\n"));
		return false;    
	}
	// _obt@Zbg
	if(FAILED(pD3DDevice->SetStreamSource( 0, m_pVertexBuf, 0, sizeof(PARTICLE) )))
	{
		ASSERT_MSG(_T("_\̐錾쐬Ă܂\n"));
		return false;	
	}

	return true;
}
// `
bool PointSprite::Draw(IDirect3DDevice9* pD3DDevice)
{
	if(!this->SetBuffer(pD3DDevice))
		return false;

	// `
	if(FAILED(pD3DDevice->DrawPrimitive( D3DPT_POINTLIST, 0, (UINT)m_ParticleNum))){
		ASSERT_MSG(_T("|CgXvCg`Ɏs܂\n"));
		return false;
	}
	
	return true;
}

// RXgN^
PointSprite::PointSprite()
	:m_pVertexDecl(NULL),m_pVertexBuf(NULL),m_ParticleNum(0),m_ElapsedTime(0.0f),
	m_ViewportHeight(0.0f),m_Accel(0,0,0)
{
}
// fXgN^
PointSprite::~PointSprite()
{
	SafeRelease(m_pVertexBuf);
	SafeRelease(m_pVertexDecl);
}

// 쐬
bool PointSprite::Create(IDirect3DDevice9* pD3DDevice,int ParticleNum)
{
	return this->CreateBuffer(pD3DDevice,ParticleNum);
}

//----------------------------------------------------------------------------//
//	|Cgv~eBu̍őTCY擾
//	1.0f ɐݒ肳ĂꍇÃfoCXł̓|CgTCY𐧌ł܂
//	̒l͈̔͂ 1.0f ȏł 
//----------------------------------------------------------------------------//
float PointSprite::GetMaxPointSize(IDirect3DDevice9* pD3DDevice){
	D3DCAPS9 Caps;
	pD3DDevice->GetDeviceCaps(&Caps);
	return Caps.MaxPointSize;
}

// x̃Zbg
void PointSprite::SetAccel(const D3DXVECTOR3& Accel)
{
	m_Accel = Accel;
}	

// oߎԃZbg
void PointSprite::ResetTime()
{
	m_ElapsedTime = 0.0f;
}

// oߎԍXV
void PointSprite::AdvanceTime(float DeltaTime)
{
	m_ElapsedTime += DeltaTime;
}
// oߎԎ擾
float PointSprite::GetTime(){
	return m_ElapsedTime;
}

