
#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "drawer.h"
#include "debugcamera.h"
#include "rendertarget.h"


class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	DirectInput	m_DirectInput;
	Texture		m_Texture;
	Texture		m_RenderTarget;
	Sprite		m_Sprite;
	DebugCamera	m_Camera;

public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
    
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());

		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,30,-100),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		
		// XvCg쐬
		m_Sprite.Create(m_Direct3D9.GetDevice(),lpCreateStruct->cx/3,lpCreateStruct->cy/3);
		// XvCgʒuZbg
		m_Sprite.SetPos(lpCreateStruct->cx/6,lpCreateStruct->cy/6);

		// _[^[Qbg쐬
		m_RenderTarget.Create(m_Direct3D9.GetDevice(),lpCreateStruct->cx,lpCreateStruct->cy);
		

		SetSamplerState(m_Direct3D9.GetDevice(),SAMPLER_LINEAR);

		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle(){

		// ͍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		if(m_Direct3D9.BeginScene()){

			// _[^[Qbg̕ύX
			SetRenderTarget(m_RenderTarget);
			// _[^[QbghԂ
			m_Direct3D9.ScreenClear(0xff000000);

			// _[Xe[g̕ύX
			SetRenderState(m_Direct3D9.GetDevice(),RENDER_DEFAULT);

			Drawer::DrawGrid(100.0f);
			Geometory::DrawAxis(50.0f);
			D3DXMATRIX ScaleMtx;
			D3DXMatrixScaling(&ScaleMtx,10,10,10);
			// Op``
			D3DXVECTOR3 filltri[3] = { D3DXVECTOR3(-2,-2,10),D3DXVECTOR3(0,3,10),D3DXVECTOR3(2,-2,10)};
			Geometory::DrawFillTriangle(filltri,&ScaleMtx);

			// _[^[Qbg̕ύX
			SetRenderTarget(m_Direct3D9);
			// _[^[QbghԂ
			m_Direct3D9.ScreenClear(0xff808080);

			// _[Xe[g̕ύX
			SetRenderState(m_Direct3D9.GetDevice(),RENDER_DEFAULT);
			
			Drawer::DrawGrid(100.0f);
			Drawer::DrawAxis(50.0f);

			// XvCg`
			Drawer::DrawPlanePolygon(m_Sprite,m_RenderTarget);


			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}