#include "sprite.h"

// RXgN^
Sprite::Sprite()
	:m_ScaleVec(1.0f,1.0f),m_RotateZ(0.0f),m_TransVec(0.0f,0.0f)
{
}
// fXgN^
Sprite::~Sprite()
{}

// XvCg쐬
bool Sprite::Create(IDirect3DDevice9* pD3DDevice,int Width,int Height,int X,int Y,float Angle)
{
	if(!this->CreateBuffer(pD3DDevice))
		return false;

	this->SetSize(Width,Height);
	this->SetAngle(Angle);
	this->SetPos(X,Y);
	
	return true;
}	

// TCYZbg
void Sprite::SetSize(int Width,int Height){
	m_ScaleVec.x = (float)Width;
	m_ScaleVec.y = (float)Height;
}
// ]Zbg
void Sprite::SetAngle(float Angle){
	m_RotateZ = Angle;
}
// ʒuZbg
void Sprite::SetPos(int X,int Y){
	m_TransVec.x = (float)X;
	m_TransVec.y = (float)Y;
}
// TCYXV
void Sprite::UpdateSize(int Width,int Height){
	m_ScaleVec.x += (float)Width;
	m_ScaleVec.y += (float)Height;
}
// ]XV
void Sprite::UpdateAngle(float Angle){
	m_RotateZ += Angle;
}
// ʒuXV
void Sprite::UpdatePos(int X,int Y){
	m_TransVec.x += X;
	m_TransVec.y += Y;
}
// 擾
int Sprite::GetWidth(){
	return (int)m_ScaleVec.x;
}
// 擾
int Sprite::GetHeight(){
	return (int)m_ScaleVec.y;
}
// ]擾
float Sprite::GetAngle(){
	return m_RotateZ;
}
// ʒu擾
D3DXVECTOR2 Sprite::GetPos(){
	return m_TransVec;
}

// s̍XV
void Sprite::Update(IDirect3DDevice9* pD3DDevice)
{
	// [hϊs쐬
	D3DXMATRIX ScaleMtx,RotateMtx,TransMtx;
	D3DXMatrixScaling(&ScaleMtx,m_ScaleVec.x,m_ScaleVec.y,0.0f);
	D3DXMatrixRotationZ(&RotateMtx,m_RotateZ);
	D3DXMatrixTranslation(&TransMtx,m_TransVec.x,m_TransVec.y ,0.0f);
	m_WorldMtx = ScaleMtx * RotateMtx * TransMtx;
	// r[|[g擾
	D3DVIEWPORT9 ViewPort;
	pD3DDevice->GetViewport(&ViewPort);
	// XN[ϊsir[|[gϊs̋tsj
	D3DXMatrixIdentity(&m_ToScreenMtx);
	m_ToScreenMtx._11 = 1.0f/(ViewPort.Width/2.0f);
	m_ToScreenMtx._22 = -1.0f/(ViewPort.Height/2.0f);
	m_ToScreenMtx._41 = -1.0f;
	m_ToScreenMtx._42 = 1.0f; 
	// UV؂s쐬
	this->CreateUVMatrix();
}
