//--------------------------------------//
//	DirectInputNX					//
//										//
//	쐬	Daiki Terai					//
//	쐬	2009/12/18					//
//	C							//
//--------------------------------------//

#include "directinput.h"



//-------------------------------------------
//	RXgN^
//-------------------------------------------
DirectInput::DirectInput()
	:m_pInput(NULL),m_pKbdDevice(NULL),m_pMseDevice(NULL),
	m_nKeyCurrentIdx(0),m_nMseCurrentIdx(0),m_nJoyCurrentIdx(0),
	m_nJpdIndex(0)
{
	memset(m_pJpdDevice,0,sizeof(LPDIRECTINPUTDEVICE8) * JOYPAD_MAX);

	memset(m_KeyDeviceState,0,sizeof(unsigned char) * KEY_MAX * 2);
	memset(m_MseDeviceState,0,sizeof(DIMOUSESTATE2) * 2);
	memset(m_JpdDeviceState,0,sizeof(DIJOYSTATE2) * JOYPAD_MAX * 2);
}

//-------------------------------------------
//	fXgN^
//-------------------------------------------
DirectInput::~DirectInput()
{
	// JoypadpDirectInputfoCX
	for(int i = 0; i < JOYPAD_MAX; ++i){
		if(m_pJpdDevice[i] != NULL)
			m_pJpdDevice[i]->Unacquire();
		SafeRelease(m_pJpdDevice[i]);
	}

	// MousepDirectInputfoCX
	if(m_pMseDevice != NULL)
		m_pMseDevice->Unacquire();
	SafeRelease(m_pMseDevice);

	// KeyboardpDirectInputfoCX
	if(m_pKbdDevice != NULL)
		m_pKbdDevice->Unacquire();
	SafeRelease(m_pKbdDevice);

	// DirectInputC^[tFCX̉
	SafeRelease(m_pInput);
}


// ------------------------------------------
//	Oj	Create
//
//	Tvj	eDirectInputfoCX쐬
//
//	j	hInst				CX^Xnh
//			hWnd				EBhEnh
//
//	߂ljtrue	
//			false	s
// ------------------------------------------
bool DirectInput::Create(HINSTANCE hInst, HWND hWnd)
{
	//------------------------ DirectInput̏ ----------------------------//
	if (FAILED(DirectInput8Create(hInst, DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&m_pInput, NULL)))
		return false;

	//------------------------ L[{[h̏ ----------------------------//
	
	// L[{[hfoCX̍쐬
	if (FAILED(m_pInput->CreateDevice(GUID_SysKeyboard, &m_pKbdDevice, NULL)))
		return false;

	// f[^tH[}bgL[{[hpɃZbg
	m_pKbdDevice->SetDataFormat(&c_dfDIKeyboard);

	// x̐ݒ
	m_pKbdDevice->SetCooperativeLevel(hWnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);

	// f[^擾Jn
	m_pKbdDevice->Acquire();

	//------------------------ }EX̏ ----------------------------//

	// }EXfoCX̐
	if (FAILED(m_pInput->CreateDevice(GUID_SysMouse, &m_pMseDevice, NULL)))
		return false;

	// f[^tH[}bg}EXpɃZbg
	m_pMseDevice->SetDataFormat(&c_dfDIMouse2);

	// x̐ݒ
	m_pMseDevice->SetCooperativeLevel(hWnd, DISCL_EXCLUSIVE | DISCL_BACKGROUND);

	// f[^擾Jn
	m_pMseDevice->Acquire();

	//------------------------ WCpbh̏ ----------------------------//

	// WCpbhfoCX
	//if (FAILED(m_pInput->EnumDevices(DI8DEVCLASS_GAMECTRL, GetJoystickCallback,NULL /*this*/, DIEDFL_ATTACHEDONLY)))
	if (FAILED(m_pInput->EnumDevices(DI8DEVCLASS_GAMECTRL, GetJoystickCallback,this,DIEDFL_ATTACHEDONLY)))
		return false;


	// WCpbhȂ
	if (!m_pJpdDevice)
		return true;

	//f[^tH[}bgWCXeBbNpɃZbg
	for(int i = 0; i < m_nJpdIndex; ++i)
	{
		if (FAILED(m_pJpdDevice[i]->SetDataFormat(&c_dfDIJoystick2)))
			return false;

		// x̐ݒ
		if (FAILED(m_pJpdDevice[i]->SetCooperativeLevel(hWnd,DISCL_EXCLUSIVE | DISCL_BACKGROUND)))
			return false;

		// ̒l͈̔͂ݒ
		DIPROPRANGE diprg; 
		ZeroMemory(&diprg, sizeof(diprg));
		diprg.diph.dwSize	= sizeof(diprg); 
		diprg.diph.dwHeaderSize	= sizeof(diprg.diph); 
		diprg.diph.dwHow	= DIPH_BYOFFSET; 
		diprg.lMin	= -StickRange; 
		diprg.lMax	=  StickRange; 
		// X͈̔͂ݒ
		diprg.diph.dwObj	= DIJOFS_X;
		m_pJpdDevice[i]->SetProperty(DIPROP_RANGE, &diprg.diph);
		// Y͈̔͂ݒ
		diprg.diph.dwObj	= DIJOFS_Y; 
 		m_pJpdDevice[i]->SetProperty(DIPROP_RANGE, &diprg.diph);
		// Z͈̔͂ݒ
		diprg.diph.dwObj	= DIJOFS_Z; 
		m_pJpdDevice[i]->SetProperty(DIPROP_RANGE, &diprg.diph);
		// Z͈̔͂ݒ
		diprg.diph.dwObj	= DIJOFS_RZ; 
		m_pJpdDevice[i]->SetProperty(DIPROP_RANGE, &diprg.diph);
		diprg.diph.dwObj	= DIJOFS_SLIDER(0); 
		m_pJpdDevice[i]->SetProperty(DIPROP_RANGE, &diprg.diph);

		// f[^̎擾Jn
		m_pJpdDevice[i]->Acquire();
	}

	// I
	//atexit(DirectInput::Release);

	return true;
}


// ----------------------------------------------------
//	Oj	GetJoystickCallback
//
//	Tvj	WCXeBbN擾
//
//	j	Ȃ
//
//	߂ljDIENUM_CONTINUE
//			DIENUM_STOP
// ----------------------------------------------------
BOOL CALLBACK DirectInput::GetJoystickCallback(const DIDEVICEINSTANCE* lpddi,void* pvRef)
{
	// LXg
	DirectInput* pObj = (DirectInput*)pvRef;// pvRef ɂ͐ this ̃AhXĂ͂

	//WCXeBbNpɃfoCXIuWFNg쐬
	LPDIRECTINPUTDEVICE8 tmp_jpdDevice;
	if(FAILED(pObj->m_pInput->CreateDevice(lpddi->guidInstance, &tmp_jpdDevice,NULL)))
		return DIENUM_CONTINUE;
	else
	{
		pObj->m_pJpdDevice[pObj->m_nJpdIndex] = tmp_jpdDevice;
		++pObj->m_nJpdIndex;
	}

	if(pObj->m_nJpdIndex >= JOYPAD_MAX)
		return DIENUM_STOP;
	else
		return DIENUM_CONTINUE;
}


// ----------------------------------------------------
//	Oj	UpdateInputState
//
//	Tvj	ԂXV
//
//	j	Ȃ
//
//	߂ljȂ
// ----------------------------------------------------
void DirectInput::UpdateInputState()
{
	// 0, 1 ݂ɓւ
	m_nKeyCurrentIdx ^= 1;
	m_nMseCurrentIdx ^= 1;
	m_nJoyCurrentIdx ^= 1;

	// L[{[h
	if (FAILED(m_pKbdDevice->GetDeviceState(sizeof(char) * KEY_MAX, &m_KeyDeviceState[m_nKeyCurrentIdx])))
	{
		// 擾Jn
		m_pKbdDevice->Acquire();
		if (FAILED(m_pKbdDevice->GetDeviceState(sizeof(char) * KEY_MAX, &m_KeyDeviceState[m_nKeyCurrentIdx])))
		{
			::memset(m_KeyDeviceState, 0, sizeof(m_KeyDeviceState));
			m_nKeyCurrentIdx = 0;
		}
	}

	// }EX
	if (FAILED(m_pMseDevice->GetDeviceState(sizeof(DIMOUSESTATE2), &m_MseDeviceState[m_nMseCurrentIdx])))
	{
		// 擾Jn
		m_pMseDevice->Acquire();
		if (FAILED(m_pMseDevice->GetDeviceState(sizeof(DIMOUSESTATE2), &m_MseDeviceState[m_nMseCurrentIdx])))
		{
			::memset(m_MseDeviceState, 0, sizeof(m_MseDeviceState));
			m_nMseCurrentIdx = 0;
		}
	}

	// WCpbh
	for (int i = 0; i < m_nJpdIndex; ++i)
	{
		if (m_pJpdDevice[i])
		{
			if (FAILED(m_pJpdDevice[i]->GetDeviceState(sizeof(DIJOYSTATE2), &m_JpdDeviceState[i][m_nJoyCurrentIdx])))
			{
				// 擾Jn
				m_pJpdDevice[i]->Acquire();
				if (FAILED(m_pJpdDevice[i]->GetDeviceState(sizeof(DIJOYSTATE2), &m_JpdDeviceState[i][m_nJoyCurrentIdx])))
				{
//					::memset(m_JpdDeviceState[i], 0, sizeof(m_JpdDeviceState));
					m_nJoyCurrentIdx = 0;
				}
			}
		}
	}
}

// ----------------------------------------------------
//	Oj	GetKeyInputState
//
//	Tvj	L[̉Ԏ擾
//
//	j	DIK		擾L[R[h
//
//	߂lj0(INPUTSTATE_FREE)		ꑱĂ
//			1(INPUTSTATE_FREE_EDGE)	ꂽu
//			2(INPUTSTATE_PUSH)		ꑱĂ
//			3(INPUTSTATE_PUSH_EDGE)	ꂽu
// ----------------------------------------------------
int DirectInput::GetKeyInputState(unsigned int DIK)
{
	unsigned int ret = INPUTSTATE_FREE;
	if (m_KeyDeviceState[m_nKeyCurrentIdx][DIK] & 0x80)
		ret = (m_KeyDeviceState[m_nKeyCurrentIdx^1][DIK] & 0x80) ? INPUTSTATE_PUSH : INPUTSTATE_PUSH_EDGE;
	else
		ret = (m_KeyDeviceState[m_nKeyCurrentIdx^1][DIK] & 0x80) ? INPUTSTATE_FREE_EDGE : INPUTSTATE_FREE;

	return ret;
}


// ----------------------------------------------------
//	Oj	GetMouseInputState
//
//	Tvj	}EX̉Ԏ擾
//
//	j	vk		擾}EX{^
//
//	߂lj0(INPUTSTATE_FREE)		ꑱĂ
//			1(INPUTSTATE_FREE_EDGE)	ꂽu
//			2(INPUTSTATE_PUSH)		ꑱĂ
//			3(INPUTSTATE_PUSH_EDGE)	ꂽu
// ----------------------------------------------------
int DirectInput::GetMouseInputState(unsigned int vk)
{
	unsigned int ret = INPUTSTATE_FREE;

	// {^
	if (m_MseDeviceState[m_nMseCurrentIdx].rgbButtons[vk] & 0x80)
		ret = (m_MseDeviceState[m_nMseCurrentIdx^1].rgbButtons[vk] & 0x80) ? INPUTSTATE_PUSH : INPUTSTATE_PUSH_EDGE;
	else
		ret = (m_MseDeviceState[m_nMseCurrentIdx^1].rgbButtons[vk] & 0x80) ? INPUTSTATE_FREE_EDGE : INPUTSTATE_FREE;

	return ret;
}

// ------------------------------------------------------------------
//	Oj	GetMouseMove
//
//	Tvj	}EXړl̎擾
//
//	j	vk		}EXړ擾}EX
//
//	߂ljret	ړl
// ------------------------------------------------------------------
LONG DirectInput::GetMouseMove(unsigned int vk)
{
	LONG ret = 0;

	switch(vk)
	{
	case MOUSE_lX:
		if(m_MseDeviceState[m_nMseCurrentIdx].lX < -1 || m_MseDeviceState[m_nMseCurrentIdx].lX > 1)
		{
			ret = m_MseDeviceState[m_nMseCurrentIdx].lX;
		}
		break;
	case MOUSE_lY:
		if(m_MseDeviceState[m_nMseCurrentIdx].lY < -1 || m_MseDeviceState[m_nMseCurrentIdx].lY > 1)
		{
			ret = m_MseDeviceState[m_nMseCurrentIdx].lY;
		}
	case MOUSE_lZ:
		if(m_MseDeviceState[m_nMseCurrentIdx].lZ < -1 || m_MseDeviceState[m_nMseCurrentIdx].lZ > 1)
		{
			ret = m_MseDeviceState[m_nMseCurrentIdx].lZ;
		}
		break;
	}
	
	return ret;
}



// ----------------------------------------------------
//	Oj	GetJoypadState
//
//	Tvj	WCpbh̉Ԏ擾
//
//	j	vk		擾{^
//			index	擾foCX̃CfbNX
//
//	߂lj	0(INPUTSTATE_FREE)		ꑱĂ
//				1(INPUTSTATE_FREE_EDGE)	ꂽu
//				2(INPUTSTATE_PUSH)		ꑱĂ
//				3(INPUTSTATE_PUSH_EDGE)	ꂽu
// ----------------------------------------------------
int DirectInput::GetJoypadState(unsigned int vk, const int index)
{
	unsigned int ret = INPUTSTATE_FREE;
	
	if (m_pJpdDevice[index])
	{
		// WCXeBbNɃ|[
 		if (FAILED(m_pJpdDevice[index]->Poll()))
		{
			m_pJpdDevice[index]->Acquire();
			while((m_pJpdDevice[index]->Acquire()) == DIERR_INPUTLOST)
			{
				m_pJpdDevice[index]->Acquire();	
			}
			return 0;
		}

		if (FAILED(m_pJpdDevice[index]->GetDeviceState(sizeof(DIJOYSTATE2), &m_JpdDeviceState[index][m_nJoyCurrentIdx])))
		{
			return 0;
		}

		// {^͔̓
		if (m_JpdDeviceState[index][m_nJoyCurrentIdx].rgbButtons[vk] & 0x80)
		{
			ret= (m_JpdDeviceState[index][m_nJoyCurrentIdx^1].rgbButtons[vk] & 0x80) ? INPUTSTATE_PUSH : INPUTSTATE_PUSH_EDGE;
		}
		else
		{
			ret= (m_JpdDeviceState[index][m_nJoyCurrentIdx^1].rgbButtons[vk] & 0x80) ? INPUTSTATE_FREE_EDGE : INPUTSTATE_FREE;
		}

	}

	return ret;
}

// ----------------------------------------------------
//	Oj	GetJoystickLean
//
//	Tvj	WCXeBbŇXԎ擾
//
//	j	vk		擾WCpbȟX
//			index	擾foCX̃CfbNX
//
//	߂lj0(INPUTSTATE_NONE)		ȂX
//			1(INPUTSTATE_SHALLOW)	̌X
//			2(INPUTSTATE_MAX)		傫X
// ----------------------------------------------------
int DirectInput::GetJoystickLean(unsigned int vk, const int index)
{
	unsigned int ret = INPUTSTATE_NONE;

	if (m_pJpdDevice[index])
	{
		// WCXeBbNɃ|[
		if (FAILED(m_pJpdDevice[index]->Poll()))
		{
			m_pJpdDevice[index]->Acquire();
			while((m_pJpdDevice[index]->Acquire()) == DIERR_INPUTLOST)
			{
				m_pJpdDevice[index]->Acquire();	
			}
			return 0;
		}

		if (FAILED(m_pJpdDevice[index]->GetDeviceState(sizeof(DIJOYSTATE2), &m_JpdDeviceState[index][m_nJoyCurrentIdx])))
		{
			return 0;
		}

		// WCXeBbN͔̓
		switch (vk)
		{
		case lX_RIGHT:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX > StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX > StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		case lX_LEFT:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX < -StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX < -StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		case lY_DOWN:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY > StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY > StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		case lY_UP:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY < -StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY < -StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		case lRz_UP:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz < -StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz < -StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		case lRz_DOWN:
			if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz > StickMax)
			{
				ret = INPUTSTATE_MAX;
			}
			else if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz > StickShallow)
			{
				ret = INPUTSTATE_SHALLOW;
			}
			break;
		
		}
	}

	return ret;
}

// ----------------------------------------------------
//	Oj	GetJoystickInclination
//
//	Tvj	WCXeBbŇXl擾
//
//	j	vk		擾WCpbȟXl
//			index	擾foCX̃CfbNX
//
//	߂ljinclination		X̒l
// ----------------------------------------------------
LONG DirectInput::GetJoystickInclination(unsigned int vk, const int index)
{
	LONG ret = 0;

	if (m_pJpdDevice[index])
	{
		// WCXeBbNɃ|[
 		if (FAILED(m_pJpdDevice[index]->Poll()))
		{
			m_pJpdDevice[index]->Acquire();
			while((m_pJpdDevice[index]->Acquire()) == DIERR_INPUTLOST)
			{
				m_pJpdDevice[index]->Acquire();	
			}
			return 0;
		}

		if (FAILED(m_pJpdDevice[index]->GetDeviceState(sizeof(DIJOYSTATE2), &m_JpdDeviceState[index][m_nJoyCurrentIdx])))
		{
			return 0;
		}

		// WCXeBbN͔̓
		switch (vk)
		{
			case lX_INC:
				if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lX < -StickShallow)
				{
					ret = m_JpdDeviceState[index][m_nJoyCurrentIdx].lX;
				}
				break;
			case lY_INC:
				if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lY < -StickShallow)
				{
					ret = m_JpdDeviceState[index][m_nJoyCurrentIdx].lY;
				}
				break;
			case lZ_INC:
				if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lZ > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lZ < -StickShallow)
				{
					ret = m_JpdDeviceState[index][m_nJoyCurrentIdx].lZ;
				}
				break;
			case lRZ_INC:
				if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz < -StickShallow)
				{
					ret = m_JpdDeviceState[index][m_nJoyCurrentIdx].lRz;
				}
				break;
		}
	}

	return ret;
}

// ----------------------------------------------------
//	Oj	GetJoystickRadian
//
//	Tvj	WCXeBbN̊px擾
//
//	j	index	擾foCX̃CfbNX
//
//	߂ljradian	px
// ----------------------------------------------------
float DirectInput::GetJoystickRadian(const int index)
{
	// WCXeBbN Xl, Yl 擾
	float stickX = .0f;
	float stickY = .0f;
	if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lX < -StickShallow)
	{
		stickX = static_cast<float>(m_JpdDeviceState[index][m_nJoyCurrentIdx].lX);
	}
	if(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY > StickShallow || m_JpdDeviceState[index][m_nJoyCurrentIdx].lY < -StickShallow)
	{
		stickY = -static_cast<float>(m_JpdDeviceState[index][m_nJoyCurrentIdx].lY);
	}

	D3DXVECTOR2 axis(.0f, 1.0f);
	D3DXVECTOR2 stick(stickX, stickY);
	D3DXVec2Normalize(&stick, &stick);

	float radian = acosf(D3DXVec2Dot(&axis, &stick));

	return radian;
}


// ----------------------------------------------------
//	Oj	Display
//
//	Tvj	͏̏o
//
//	j	frame		t[
//			tout		o̓Xg[
//	߂ljȂ
// ----------------------------------------------------
void DirectInput::Display(unsigned long frame,std::basic_ostream<TCHAR>& tout)
{
#if _DEBUG
	
	// L[̎擾
	for(int i = 0;i < KEY_MAX;++i)
	{
		if(GetKeyInputState(i) == INPUTSTATE_PUSH_EDGE)
		{
			tout << _T("frame = ") << frame << ": ";
			tout << _T("key push ") <<  i << std::endl;
		}
	}

	// }EX̎擾
	for(int i = 0;i < MOUSEBUTTON_MAX;++i)
	{
		if(GetMouseInputState(i) == INPUTSTATE_PUSH_EDGE){
			tout << _T("frame = ") << frame << ": ";
			tout << _T("mouse click ") << i << std::endl;
		}
	}
	int mouseX = GetMouseMove(MOUSE_lX);
	int mouseY = GetMouseMove(MOUSE_lY);
	if(mouseX != 0 || mouseY != 0){
		tout << _T("frame = ") << frame << ": ";
		tout << _T("mouse move X = ") << mouseX;
		tout << _T(" mouse move Y = ") << mouseY; 
		tout << std::endl;
	}

	// WCpbh̎擾
	for(int i = 0;i < JOYPAD_MAX;++i)
	{
		for(int j = 0;j < JOYBUTTON_MAX;++j)
		{
			if(GetJoypadState(j,i) == INPUTSTATE_PUSH_EDGE){
				tout << _T("frame = ") << frame << ": ";
				tout << _T("joypad %d push button %d\n") << i << j;
				tout << std::endl;
			}
		}

		int lX = GetJoystickInclination(lX_INC,i);
		int lY = GetJoystickInclination(lY_INC,i);
		int lZ = GetJoystickInclination(lZ_INC,i);
		int lRZ = GetJoystickInclination(lRZ_INC,i);
		if(lX != 0 || lY != 0){
			tout << _T("frame = ") << frame << ": ";
			tout << _T("joypad = ") << i;
			tout << _T(" stick ");
			tout << _T("lX = ") << lX;
			tout << _T("lY = ") << lY;
			tout << std::endl;
		}
		if(lZ != 0 || lRZ != 0){
			tout << _T("frame = ") << frame << ": ";
			tout << _T("joypad = ") << i;
			tout << _T(" stick ");
			tout << _T("lZ = ") << lZ;
			tout << _T("lRZ = ") << lRZ;
			tout << std::endl;
		}

	}

#endif
}