#include "window.h"
#include "direct3d9.h"
#include "directinput.h"
#include "geometory.h"
#include "debugcamera.h"
#include "drawer.h"
#include "texture.h"

class WindowEx : public Window
{
private:
	Direct3D9	m_Direct3D9;
	DirectInput	m_DirectInput;
	DebugCamera	m_Camera;
	Texture		m_Texture;
	Sprite		m_Sprite;
public:

    // EBhȄ
    virtual BOOL OnCreate(HWND hWnd,LPCREATESTRUCT lpCreateStruct){
		// 3DfoCX쐬
		m_Direct3D9.Create(hWnd,lpCreateStruct->cx,lpCreateStruct->cy);
		// ̓foCX쐬
		m_DirectInput.Create((HINSTANCE)GetModuleHandle(NULL),hWnd);
		// GtFNgǂݍ
		Drawer::LoadEffect(m_Direct3D9.GetDevice());
		
		// JʒuA_Zbg
		m_Camera.SetEyeAtPos(D3DXVECTOR3(0,20,-10),D3DXVECTOR3(0,5,0));
		// ˉeϊs쐬
		m_Camera.SetProjMatrix((float)lpCreateStruct->cx/(float)lpCreateStruct->cy);
		// ˉeϊsZbg
		Object3D::SetProjMtx(m_Camera.GetProjMatrix());
		
		
		// eNX`ǂݍ
		m_Texture.Create(_T("player.png"),m_Direct3D9.GetDevice(),384,384,0xff78c380);
		// XvCg쐬
		m_Sprite.Create(m_Direct3D9.GetDevice(),32,48);

		// ʒuZbg
		m_Sprite.SetPos(100,100);
		// TCYZbg
		m_Sprite.SetSize(64,96);
		// UV؂蔲
		m_Sprite.SetDivideUV(12,8);
		// UVZbg
		m_Sprite.SetUV(1,0);

		m_Sprite.AddAnimationUV(_T("DownWalk"),0,0,10);
		m_Sprite.AddAnimationUV(_T("DownWalk"),2,0,10);
		m_Sprite.AddAnimationUV(_T("UpWalk"),0,3,10);
		m_Sprite.AddAnimationUV(_T("UpWalk"),2,3,10);
		m_Sprite.AddAnimationUV(_T("LeftWalk"),0,1,10);
		m_Sprite.AddAnimationUV(_T("LeftWalk"),2,1,10);
		m_Sprite.AddAnimationUV(_T("RightWalk"),0,2,10);
		m_Sprite.AddAnimationUV(_T("RightWalk"),2,2,10);

		// _[Xe[g̕ύX
		SetRenderState(m_Direct3D9.GetDevice(),RENDER_ALPHATEST);
		// Tv[Xe[g̕ύX
		SetSamplerState(m_Direct3D9.GetDevice(),SAMPLER_LINEAR);

		return TRUE;
    }
    
    // DirectX̏
    virtual void Idle()
	{
		// ͏Ԃ̍XV
		m_DirectInput.UpdateInputState();
		// JXV
		m_Camera.DebugUpdate(m_DirectInput);
		// r[ϊsZbg
		Object3D::SetViewMtx(m_Camera.GetViewMatrix());

		const int move = 2;
		bool isMove = false;
		POINT pt = {};
		std::basic_string<TCHAR> AnimationName;
		if(m_DirectInput.GetKeyInputState(DIK_W) == INPUTSTATE_PUSH){
			pt.x = 0;
			pt.y = -move;
			isMove = true;
			AnimationName = _T("UpWalk");
		}
		if(m_DirectInput.GetKeyInputState(DIK_S) == INPUTSTATE_PUSH){
			pt.x = 0;
			pt.y = move;
			isMove = true;
			AnimationName = _T("DownWalk");
		}
		if(m_DirectInput.GetKeyInputState(DIK_A) == INPUTSTATE_PUSH){
			pt.x = -move;
			pt.y = 0;
			isMove = true;
			AnimationName = _T("LeftWalk");
		}
		if(m_DirectInput.GetKeyInputState(DIK_D) == INPUTSTATE_PUSH){
			pt.x = move;
			pt.y = 0;
			isMove = true;
			AnimationName = _T("RightWalk");
		}
		if(isMove){
			if(m_Sprite.GetAnimationName() != AnimationName)
				m_Sprite.SetAnimation(AnimationName.c_str());
			m_Sprite.UpdatePos(pt.x,pt.y);
			m_Sprite.UpdateAnimation();
		}

		if(m_DirectInput.GetKeyInputState(DIK_J) == INPUTSTATE_PUSH){
			m_Sprite.UpdateAngle(0.01f);
		}
		if(m_DirectInput.GetKeyInputState(DIK_K) == INPUTSTATE_PUSH){
			m_Sprite.UpdateAngle(-0.01f);
		}

		// ʓhԂ
		m_Direct3D9.ScreenClear(0xff808080);
		if(m_Direct3D9.BeginScene()){

			Drawer::DrawGrid(10.0f);
			Drawer::DrawAxis(5.0f);

			// XvCg`
			Drawer::DrawPlanePolygon(m_Sprite,m_Texture);
			
			m_Direct3D9.EndScene();
		}

		m_Direct3D9.Present();
    }
};

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	// fobNR\[
	//Console console;
	// [No
	CRTMEMORYLEAK_CHECK();
	// [Nӏo
	//CRTMEMORYLEAK_POINT(10);

	// CEBhE
    WindowEx windowex;
    windowex.CreateWnd(_T("Application"),640,480);
    
    Window::MessageLoop();
    return 0;
}