//--------------------------------------//
//	DirectInputNX					//
//										//
//	쐬	Daiki Terai					//
//	쐬	2009/12/18					//
//	C							//
//--------------------------------------//

#ifndef _DIRECTINPUT_H_
#define _DIRECTINPUT_H_

#include "safefree.hpp"

/*---------------------------------------------------------------------------*/
#pragma warning (disable : 4819)			// t@ĆÃ݂R[h y[W (932) ŕ\łȂ܂ł܂Bf[^̑h߂ɁAt@C Unicode `ŕۑĂB
#define DIRECTINPUT_VERSION         0x800	// DirectInput̃o[W
/*---------------------------------------------------------------------------*/
#pragma comment(lib, "dinput8.lib")
#pragma comment(lib, "dxguid.lib")
/*---------------------------------------------------------------------------*/
#include <tchar.h>
#include <stdlib.h>
#include <dinput.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <windows.h>
#include <map>
#include <string>
#pragma warning (default : 4819)			
/*---------------------------------------------------------------------------*/

static const int KEY_MAX			= 0x100;		// L[̍ő吔
static const int MOUSEBUTTON_MAX	= 0x008;		// }EX{^̍ő吔
static const int JOYBUTTON_MAX		= 0x080;		// WCpbh{^̍ő吔


// L[R[hꗗ
#if 0
#define DIK_ESCAPE          0x01
#define DIK_1               0x02
#define DIK_2               0x03
#define DIK_3               0x04
#define DIK_4               0x05
#define DIK_5               0x06
#define DIK_6               0x07
#define DIK_7               0x08
#define DIK_8               0x09
#define DIK_9               0x0A
#define DIK_0               0x0B
#define DIK_MINUS           0x0C    /* - on main keyboard */
#define DIK_EQUALS          0x0D
#define DIK_BACK            0x0E    /* backspace */
#define DIK_TAB             0x0F
#define DIK_Q               0x10
#define DIK_W               0x11
#define DIK_E               0x12
#define DIK_R               0x13
#define DIK_T               0x14
#define DIK_Y               0x15
#define DIK_U               0x16
#define DIK_I               0x17
#define DIK_O               0x18
#define DIK_P               0x19
#define DIK_LBRACKET        0x1A
#define DIK_RBRACKET        0x1B
#define DIK_RETURN          0x1C    /* Enter on main keyboard */
#define DIK_LCONTROL        0x1D
#define DIK_A               0x1E
#define DIK_S               0x1F
#define DIK_D               0x20
#define DIK_F               0x21
#define DIK_G               0x22
#define DIK_H               0x23
#define DIK_J               0x24
#define DIK_K               0x25
#define DIK_L               0x26
#define DIK_SEMICOLON       0x27
#define DIK_APOSTROPHE      0x28
#define DIK_GRAVE           0x29    /* accent grave */
#define DIK_LSHIFT          0x2A
#define DIK_BACKSLASH       0x2B
#define DIK_Z               0x2C
#define DIK_X               0x2D
#define DIK_C               0x2E
#define DIK_V               0x2F
#define DIK_B               0x30
#define DIK_N               0x31
#define DIK_M               0x32
#define DIK_COMMA           0x33
#define DIK_PERIOD          0x34    /* . on main keyboard */
#define DIK_SLASH           0x35    /* / on main keyboard */
#define DIK_RSHIFT          0x36
#define DIK_MULTIPLY        0x37    /* * on numeric keypad */
#define DIK_LMENU           0x38    /* left Alt */
#define DIK_SPACE           0x39
#define DIK_CAPITAL         0x3A
#define DIK_F1              0x3B
#define DIK_F2              0x3C
#define DIK_F3              0x3D
#define DIK_F4              0x3E
#define DIK_F5              0x3F
#define DIK_F6              0x40
#define DIK_F7              0x41
#define DIK_F8              0x42
#define DIK_F9              0x43
#define DIK_F10             0x44
#define DIK_NUMLOCK         0x45
#define DIK_SCROLL          0x46    /* Scroll Lock */
#define DIK_NUMPAD7         0x47
#define DIK_NUMPAD8         0x48
#define DIK_NUMPAD9         0x49
#define DIK_SUBTRACT        0x4A    /* - on numeric keypad */
#define DIK_NUMPAD4         0x4B
#define DIK_NUMPAD5         0x4C
#define DIK_NUMPAD6         0x4D
#define DIK_ADD             0x4E    /* + on numeric keypad */
#define DIK_NUMPAD1         0x4F
#define DIK_NUMPAD2         0x50
#define DIK_NUMPAD3         0x51
#define DIK_NUMPAD0         0x52
#define DIK_DECIMAL         0x53    /* . on numeric keypad */
#define DIK_OEM_102         0x56    /* <> or \| on RT 102-key keyboard (Non-U.S.) */
#define DIK_F11             0x57
#define DIK_F12             0x58
#define DIK_F13             0x64    /*                     (NEC PC98) */
#define DIK_F14             0x65    /*                     (NEC PC98) */
#define DIK_F15             0x66    /*                     (NEC PC98) */
#define DIK_KANA            0x70    /* (Japanese keyboard)            */
#define DIK_ABNT_C1         0x73    /* /? on Brazilian keyboard */
#define DIK_CONVERT         0x79    /* (Japanese keyboard)            */
#define DIK_NOCONVERT       0x7B    /* (Japanese keyboard)            */
#define DIK_YEN             0x7D    /* (Japanese keyboard)            */
#define DIK_ABNT_C2         0x7E    /* Numpad . on Brazilian keyboard */
#define DIK_NUMPADEQUALS    0x8D    /* = on numeric keypad (NEC PC98) */
#define DIK_PREVTRACK       0x90    /* Previous Track (DIK_CIRCUMFLEX on Japanese keyboard) */
#define DIK_AT              0x91    /*                     (NEC PC98) */
#define DIK_COLON           0x92    /*                     (NEC PC98) */
#define DIK_UNDERLINE       0x93    /*                     (NEC PC98) */
#define DIK_KANJI           0x94    /* (Japanese keyboard)            */
#define DIK_STOP            0x95    /*                     (NEC PC98) */
#define DIK_AX              0x96    /*                     (Japan AX) */
#define DIK_UNLABELED       0x97    /*                        (J3100) */
#define DIK_NEXTTRACK       0x99    /* Next Track */
#define DIK_NUMPADENTER     0x9C    /* Enter on numeric keypad */
#define DIK_RCONTROL        0x9D
#define DIK_MUTE            0xA0    /* Mute */
#define DIK_CALCULATOR      0xA1    /* Calculator */
#define DIK_PLAYPAUSE       0xA2    /* Play / Pause */
#define DIK_MEDIASTOP       0xA4    /* Media Stop */
#define DIK_VOLUMEDOWN      0xAE    /* Volume - */
#define DIK_VOLUMEUP        0xB0    /* Volume + */
#define DIK_WEBHOME         0xB2    /* Web home */
#define DIK_NUMPADCOMMA     0xB3    /* , on numeric keypad (NEC PC98) */
#define DIK_DIVIDE          0xB5    /* / on numeric keypad */
#define DIK_SYSRQ           0xB7
#define DIK_RMENU           0xB8    /* right Alt */
#define DIK_PAUSE           0xC5    /* Pause */
#define DIK_HOME            0xC7    /* Home on arrow keypad */
#define DIK_UP              0xC8    /* UpArrow on arrow keypad */
#define DIK_PRIOR           0xC9    /* PgUp on arrow keypad */
#define DIK_LEFT            0xCB    /* LeftArrow on arrow keypad */
#define DIK_RIGHT           0xCD    /* RightArrow on arrow keypad */
#define DIK_END             0xCF    /* End on arrow keypad */
#define DIK_DOWN            0xD0    /* DownArrow on arrow keypad */
#define DIK_NEXT            0xD1    /* PgDn on arrow keypad */
#define DIK_INSERT          0xD2    /* Insert on arrow keypad */
#define DIK_DELETE          0xD3    /* Delete on arrow keypad */
#define DIK_LWIN            0xDB    /* Left Windows key */
#define DIK_RWIN            0xDC    /* Right Windows key */
#define DIK_APPS            0xDD    /* AppMenu key */
#define DIK_POWER           0xDE    /* System Power */
#define DIK_SLEEP           0xDF    /* System Sleep */
#define DIK_WAKE            0xE3    /* System Wake */
#define DIK_WEBSEARCH       0xE5    /* Web Search */
#define DIK_WEBFAVORITES    0xE6    /* Web Favorites */
#define DIK_WEBREFRESH      0xE7    /* Web Refresh */
#define DIK_WEBSTOP         0xE8    /* Web Stop */
#define DIK_WEBFORWARD      0xE9    /* Web Forward */
#define DIK_WEBBACK         0xEA    /* Web Back */
#define DIK_MYCOMPUTER      0xEB    /* My Computer */
#define DIK_MAIL            0xEC    /* Mail */
#define DIK_MEDIASELECT     0xED    /* Media Select */
#endif


#ifndef INPUTSTATE
#define INPUTSTATE

// 
enum EInputState
{
	INPUTSTATE_FREE,			// ꑱĂ
	INPUTSTATE_FREE_EDGE,		// ꂽu
	INPUTSTATE_PUSH,			// ꑱĂ
	INPUTSTATE_PUSH_EDGE,		// ꂽu
	INPUTSTATE_ERROR			// G[
};

#endif

// }EXNbN
enum EMouseClick
{
	LEFT_CLICK	= 0,	// {^NbN
	RIGHT_CLICK	= 1,	// E{^NbN
	MIDDLE_CLICK= 2		// {^NbN
};

// }EX[
enum EMouseRoll
{
	ROLL_UP,
	ROLL_DOWN
};

// }EXړ
enum EMouseMove
{
	MOUSE_lX,
	MOUSE_lY,
	MOUSE_lZ
};


// WCpbȟX
enum ELean
{
	INPUTSTATE_NONE,	// ȂX
	INPUTSTATE_SHALLOW,	// ̌X
	INPUTSTATE_MAX		// 傫X
};

// WCpbȟX
enum ELeanPer 
{
	lX_RIGHT,
	lX_LEFT,
	lY_UP,
	lY_DOWN,
	lRz_UP,
	lRz_DOWN
};

// WCpbȟXl
enum ELeanInc
{
	lX_INC,	// XeBbNw
	lY_INC,	// XeBbNx
	lZ_INC,	// EXeBbNw
	lRZ_INC	// EXeBbNx
};

// WCpbh̔ԍ
enum EJoypadNumber
{
	JOYPAD_1,
	JOYPAD_2,
	JOYPAD_3,
	JOYPAD_4,

	JOYPAD_MAX
};

class DirectInput
{
private:
	LPDIRECTINPUT8			m_pInput;						// DirectInputIuWFNg
	
	LPDIRECTINPUTDEVICE8	m_pKbdDevice;					// L[{[hpDirectInputfoCXnh
	LPDIRECTINPUTDEVICE8	m_pMseDevice;					// }EXpDirectInputfoCXnh
	LPDIRECTINPUTDEVICE8	m_pJpdDevice[JOYPAD_MAX];		// WCpbhpDirectInputfoCXnh

	unsigned char			m_KeyDeviceState[2][KEY_MAX];	// L[̉Ԃۑĩ݂t[ƈÕt[j
	DIMOUSESTATE2			m_MseDeviceState[2];			// }EX̉Ԃۑĩ݂t[ƈÕt[j
	DIJOYSTATE2				m_JpdDeviceState[JOYPAD_MAX][2];// WCpbh̉Ԃۑĩ݂t[ƈÕt[j

	int						m_nKeyCurrentIdx;				// L[{[hCfbNXF		}Ct[ĂяoAl𔽓]
	int						m_nMseCurrentIdx;				// }EXCfbNXF			}Ct[ĂяoAl𔽓]
	int						m_nJoyCurrentIdx;				// WCpbhCfbNXF	}Ct[ĂяoAl𔽓]

	int						m_nJpdIndex;					// ڑĂWCpbh
	
	// ŊOǂݍ
	static const int StickRange		= 1000;	// XeBbN̍őXl
	static const int StickShallow	= 300;	// XeBbN̏Xl
	static const int StickMax		= 900;	// XeBbN̑傫Xl

public:

	//-------------------------------------------
	//	RXgN^
	//-------------------------------------------
	DirectInput();

	//-------------------------------------------
	//	fXgN^
	//-------------------------------------------
	virtual ~DirectInput();


	// ------------------------------------------
	//	Oj	Create
	//
	//	Tvj	eDirectInputfoCX쐬
	//
	//	j	hInst				CX^Xnh
	//			hWnd				EBhEnh
	//
	//	߂ljtrue	
	//			false	s
	// ------------------------------------------
	bool Create(HINSTANCE hInst, HWND hWnd);

private:
	// ----------------------------------------------------
	//	Oj	GetJoystickCallback
	//
	//	Tvj	WCXeBbN擾
	//
	//	߂ljDIENUM_CONTINUE
	//			DIENUM_STOP
	// ----------------------------------------------------
	static BOOL CALLBACK GetJoystickCallback(const DIDEVICEINSTANCE* lpddi,void* pvRef);

public:

	// ----------------------------------------------------
	//	Oj	UpdateInputState
	//
	//	Tvj	ԂXV
	//
	//	j	Ȃ
	//
	//	߂ljȂ
	// ----------------------------------------------------
	void UpdateInputState();

	// ----------------------------------------------------
	//	Oj	GetKeyInputState
	//
	//	Tvj	L[̉Ԏ擾
	//
	//	j	DIK		擾L[R[h
	//
	//	߂lj0(INPUTSTATE_FREE)		ꑱĂ
	//			1(INPUTSTATE_FREE_EDGE)	ꂽu
	//			2(INPUTSTATE_PUSH)		ꑱĂ
	//			3(INPUTSTATE_PUSH_EDGE)	ꂽu
	// ----------------------------------------------------
	int GetKeyInputState(unsigned int DIK);
	
	// ----------------------------------------------------
	//	Oj	GetMouseInputState
	//
	//	Tvj	}EX̉Ԏ擾
	//
	//	j	vk		擾}EX{^
	//
	//	߂lj0(INPUTSTATE_FREE)		ꑱĂ
	//			1(INPUTSTATE_FREE_EDGE)	ꂽu
	//			2(INPUTSTATE_PUSH)		ꑱĂ
	//			3(INPUTSTATE_PUSH_EDGE)	ꂽu
	// ----------------------------------------------------
	int GetMouseInputState(unsigned int vk);

	// ------------------------------------------------------------------
	//	Oj	GetMouseMove
	//
	//	Tvj	}EXړl̎擾
	//
	//	j	vk		}EXړ擾}EX
	//
	//	߂ljret	ړl
	// ------------------------------------------------------------------
	LONG GetMouseMove(unsigned int vk);

	// ----------------------------------------------------
	//	Oj	GetJoypadState
	//
	//	Tvj	WCpbh̉Ԏ擾
	//
	//	j	vk		擾{^
	//			index	擾foCX̃CfbNX
	//
	//	߂lj	0(INPUTSTATE_FREE)		ꑱĂ
	//				1(INPUTSTATE_FREE_EDGE)	ꂽu
	//				2(INPUTSTATE_PUSH)		ꑱĂ
	//				3(INPUTSTATE_PUSH_EDGE)	ꂽu
	// ----------------------------------------------------
	int GetJoypadState(unsigned int vk, const int index = 0);

	// ----------------------------------------------------
	//	Oj	GetJoystickLean
	//
	//	Tvj	WCXeBbŇXԎ擾
	//
	//	j	vk		擾WCpbȟX
	//			index	擾foCX̃CfbNX
	//
	//	߂lj0(INPUTSTATE_NONE)		ȂX
	//			1(INPUTSTATE_SHALLOW)	̌X
	//			2(INPUTSTATE_MAX)		傫X
	// ----------------------------------------------------
	int GetJoystickLean(unsigned int vk, const int index = 0);

	// ----------------------------------------------------
	//	Oj	GetJoystickInclination
	//
	//	Tvj	WCXeBbŇXl擾
	//
	//	j	vk		擾WCpbȟXl
	//			index	擾foCX̃CfbNX
	//
	//	߂ljinclination		X̒l
	// ----------------------------------------------------
	LONG GetJoystickInclination(unsigned int vk, const int index = 0);

	// ----------------------------------------------------
	//	Oj	GetJoystickRadian
	//
	//	Tvj	WCXeBbN̊px擾
	//
	//	j	index	擾foCX̃CfbNX
	//
	//	߂ljradian	px
	// ----------------------------------------------------
	float GetJoystickRadian(const int index = 0);

	// ----------------------------------------------------
	//	Oj	Display
	//
	//	Tvj	͏̏o
	//
	//	j	frame		t[
	//			tout		o̓Xg[
	//
	//	߂ljȂ
	// ----------------------------------------------------
	void Display(unsigned long frame,std::basic_ostream<TCHAR>& tout);

};


#endif